/*
  Copyright (C) 2016-2023 Dan Cazarin (https://www.kfrlib.com)
  This file is part of KFR

  KFR is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.

  KFR is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KFR.

  If GPL is not suitable for your project, you must purchase a commercial license to use KFR.
  Buying a commercial license is mandatory as soon as you develop commercial activities without
  disclosing the source code of your own applications.
  See https://www.kfrlib.com for details.
 */

#include "base.hpp"
#include "dft.hpp"
#include "dsp.hpp"
#include "io.hpp"

/** @defgroup cometa Cometa
 * @brief Metaprogramming
 */

/** @defgroup types Types
 * @brief Core types
 */

/** @defgroup expressions Expressions
 * @brief Expressions
 */

/** @defgroup shuffle Shuffle
 * @brief Vector shuffle functions
 */

/** @defgroup utility Utility
 * @brief Utility classes and functions
 */

/** @defgroup dft DFT
 * @brief Fast Fourier Transform & Direct Fourier Transform
 */

/** @defgroup dsp DSP
 * @brief Filters and other DSP-related functions
 */

/** @defgroup io IO
 * @brief Input & Output
 */

/** @defgroup math Math
 * @brief Mathematical functions
 */

/** @defgroup cpuid CPUID
 * @brief CPU detection
 */
