
Rubber Band is an open source library with a commercial licence
option. It is developed and maintained with care, prioritising
reliability, output quality, compatibility across releases and
platforms, and performance, in roughly that order.

## Bug reports

We welcome and encourage bug reports for the Rubber Band
Library. We're happy to receive them by almost any channel. The most
usual are [as Github issues](https://github.com/breakfastquay/rubberband/issues)
or [by contacting us directly](https://breakfastquay.com/contact.html).

Please try to provide enough information for us to reproduce the
problem. At the minimum this includes details of platform, compiler,
and library configuration, as well as a description of the expected
and problematic behaviour. We appreciate that describing issues
relating to audio output can be tricky, and we may ask you to send or
provide further information such as audio examples.

## Pull requests

Please be aware that we **cannot directly merge** pull requests. This
is partly for technical reasons (the Github repository for the library
is a read-only mirror of an upstream repo) and partly for control of
copyright and provenance.

Github pull requests may still be appropriate if you have small fixes,
particularly fixes to the build system or documentation, that would be
convenient to upstream. We will gratefully read and consider PRs,
especially of this sort.

If you have any more substantial changes you would like to see
included, please contact us directly to discuss.

## Other ways to contribute

An excellent way to contribute to the continued development of Rubber
Band Library is to [buy a commercial licence](https://breakfastquay.com/technology/license.html).

For enhancements and other new development work, it may be possible to
engage [Particular Programs Ltd](https://particularprograms.co.uk/) at
a commercial rate. Please contact us for details.

