// NTSTATUS code, Win32 error code equivalent, POSIX error code equivalent, NTSTATUS descriptive string in UTF8
{ static_cast<int>(0x80000001),static_cast<int>(0x0),0,"{EXCEPTION}\nGuard Page Exception\nA page of memory that marks the end of a data structure, such as a stack or an array, has been accessed."},
{ static_cast<int>(0x80000002),static_cast<int>(0x3e6),EACCES,"{EXCEPTION}\nAlignment Fault\nA datatype misalignment was detected in a load or store instruction."},
{ static_cast<int>(0x80000003),static_cast<int>(0x0),0,"{EXCEPTION}\nBreakpoint\nA breakpoint has been reached."},
{ static_cast<int>(0x80000004),static_cast<int>(0x0),0,"{EXCEPTION}\nSingle Step\nA single step or trace operation has just been completed."},
{ static_cast<int>(0x80000005),static_cast<int>(0xea),0,"{Buffer Overflow}\nThe data was too large to fit into the specified buffer."},
{ static_cast<int>(0x80000006),static_cast<int>(0x12),0,"{No More Files}\nNo more files were found which match the file specification."},
{ static_cast<int>(0x80000007),static_cast<int>(0x2a3),0,"{Kernel Debugger Awakened}\nthe system debugger was awakened by an interrupt."},
{ static_cast<int>(0x80000008),static_cast<int>(0x13d),0,"Unspecified error"},
{ static_cast<int>(0x80000009),static_cast<int>(0x13d),0,"General access denied error"},
{ static_cast<int>(0x8000000a),static_cast<int>(0x2a4),0,"{Handles Closed}\nHandles to objects have been automatically closed as a result of the requested operation."},
{ static_cast<int>(0x8000000b),static_cast<int>(0x56f),0,"{Non-Inheritable ACL}\nAn access control list (ACL) contains no components that can be inherited."},
{ static_cast<int>(0x8000000c),static_cast<int>(0x2a8),0,"{GUID Substitution}\nDuring the translation of a global identifier (GUID) to a Windows security ID (SID), no administratively-defined GUID prefix was found. A substitute prefix was used, which will not compromise system security. However, this may provide a more restrictive access than intended."},
{ static_cast<int>(0x8000000d),static_cast<int>(0x12b),0,"{Partial Copy}\nDue to protection conflicts not all the requested bytes could be copied."},
{ static_cast<int>(0x8000000e),static_cast<int>(0x1c),0,"{Out of Paper}\nThe printer is out of paper."},
{ static_cast<int>(0x8000000f),static_cast<int>(0x15),EAGAIN,"{Device Power Is Off}\nThe printer power has been turned off."},
{ static_cast<int>(0x80000010),static_cast<int>(0x15),EAGAIN,"{Device Offline}\nThe printer has been taken offline."},
{ static_cast<int>(0x80000011),static_cast<int>(0xaa),EBUSY,"{Device Busy}\nThe device is currently busy."},
{ static_cast<int>(0x80000012),static_cast<int>(0x103),0,"{No More EAs}\nNo more extended attributes (EAs) were found for the file."},
{ static_cast<int>(0x80000013),static_cast<int>(0xfe),0,"{Illegal EA}\nThe specified extended attribute (EA) name contains at least one illegal character."},
{ static_cast<int>(0x80000014),static_cast<int>(0xff),0,"{Inconsistent EA List}\nThe extended attribute (EA) list is inconsistent."},
{ static_cast<int>(0x80000015),static_cast<int>(0xff),0,"{Invalid EA Flag}\nAn invalid extended attribute (EA) flag was set."},
{ static_cast<int>(0x80000016),static_cast<int>(0x456),0,"{Verifying Disk}\nThe media has changed and a verify operation is in progress so no reads or writes may be performed to the device, except those used in the verify operation."},
{ static_cast<int>(0x80000017),static_cast<int>(0x2a5),0,"{Too Much Information}\nThe specified access control list (ACL) contained more information than was expected."},
{ static_cast<int>(0x80000018),static_cast<int>(0x2a6),0,"This warning level status indicates that the transaction state already exists for the registry sub-tree, but that a transaction commit was previously aborted.\nThe commit has NOT been completed, but has not been rolled back either (so it may still be committed if desired)."},
{ static_cast<int>(0x80000019),static_cast<int>(0x13d),0,"An async operation was not properly started."},
{ static_cast<int>(0x8000001a),static_cast<int>(0x103),0,"{No More Entries}\nNo more entries are available from an enumeration operation."},
{ static_cast<int>(0x8000001b),static_cast<int>(0x44d),0,"{Filemark Found}\nA filemark was detected."},
{ static_cast<int>(0x8000001c),static_cast<int>(0x456),0,"{Media Changed}\nThe media may have changed."},
{ static_cast<int>(0x8000001d),static_cast<int>(0x457),0,"{I/O Bus Reset}\nAn I/O bus reset was detected."},
{ static_cast<int>(0x8000001e),static_cast<int>(0x44c),0,"{End of Media}\nThe end of the media was encountered."},
{ static_cast<int>(0x8000001f),static_cast<int>(0x44e),0,"Beginning of tape or partition has been detected."},
{ static_cast<int>(0x80000020),static_cast<int>(0x2a7),0,"{Media Changed}\nThe media may have changed."},
{ static_cast<int>(0x80000021),static_cast<int>(0x44f),0,"A tape access reached a setmark."},
{ static_cast<int>(0x80000022),static_cast<int>(0x450),0,"During a tape access, the end of the data written is reached."},
{ static_cast<int>(0x80000023),static_cast<int>(0x702),0,"The redirector is in use and cannot be unloaded."},
{ static_cast<int>(0x80000024),static_cast<int>(0x713),0,"The server is in use and cannot be unloaded."},
{ static_cast<int>(0x80000025),static_cast<int>(0x962),0,"The specified connection has already been disconnected."},
{ static_cast<int>(0x80000026),static_cast<int>(0x2aa),0,"A long jump has been executed."},
{ static_cast<int>(0x80000027),static_cast<int>(0x10f4),0,"A cleaner cartridge is present in the tape library."},
{ static_cast<int>(0x80000028),static_cast<int>(0x2ab),0,"The Plug and Play query operation was not successful."},
{ static_cast<int>(0x80000029),static_cast<int>(0x2ac),0,"A frame consolidation has been executed."},
{ static_cast<int>(0x8000002a),static_cast<int>(0x2ad),0,"{Registry Hive Recovered}\nRegistry hive (file):\n%hs\nwas corrupted and it has been recovered. Some data might have been lost."},
{ static_cast<int>(0x8000002b),static_cast<int>(0x2ae),0,"The application is attempting to run executable code from the module %hs. This may be insecure. An alternative, %hs, is available. Should the application use the secure module %hs?"},
{ static_cast<int>(0x8000002c),static_cast<int>(0x2af),0,"The application is loading executable code from the module %hs. This is secure, but may be incompatible with previous releases of the operating system. An alternative, %hs, is available. Should the application use the secure module %hs?"},
{ static_cast<int>(0x8000002d),static_cast<int>(0x2a9),0,"The create operation stopped after reaching a symbolic link."},
{ static_cast<int>(0x8000002e),static_cast<int>(0x321),0,"An oplock of the requested level cannot be granted.  An oplock of a lower level may be available."},
{ static_cast<int>(0x8000002f),static_cast<int>(0x324),0,"{No ACE Condition}\nThe specified access control entry (ACE) does not contain a condition."},
{ static_cast<int>(0x80000030),static_cast<int>(0xab),0,"{Support Being Determined}\nDevice's command support detection is in progress."},
{ static_cast<int>(0x80000031),static_cast<int>(0x30207),0,"The device needs to be power cycled."},
{ static_cast<int>(0x80000032),static_cast<int>(0xeb),0,"The action requested resulted in no work being done. Error-style clean-up has been performed."},
{ static_cast<int>(0x80000288),static_cast<int>(0x48d),0,"The device has indicated that cleaning is necessary."},
{ static_cast<int>(0x80000289),static_cast<int>(0x48e),0,"The device has indicated that its door is open. Further operations require it closed and secured."},
{ static_cast<int>(0x80000803),static_cast<int>(0x1abb),0,"Windows discovered a corruption in the file \"%hs\".\nThis file has now been repaired.\nPlease check if any data in the file was lost because of the corruption."},
{ static_cast<int>(0x80004001),static_cast<int>(0x13d),0,"Not implemented"},
{ static_cast<int>(0x80004002),static_cast<int>(0x13d),0,"No such interface supported"},
{ static_cast<int>(0x80004003),static_cast<int>(0x13d),0,"Invalid pointer"},
{ static_cast<int>(0x80004004),static_cast<int>(0x13d),0,"Operation aborted"},
{ static_cast<int>(0x80004005),static_cast<int>(0x13d),0,"Unspecified error"},
{ static_cast<int>(0x80004006),static_cast<int>(0x13d),0,"Thread local storage failure"},
{ static_cast<int>(0x80004007),static_cast<int>(0x13d),0,"Get shared memory allocator failure"},
{ static_cast<int>(0x80004008),static_cast<int>(0x13d),0,"Get memory allocator failure"},
{ static_cast<int>(0x80004009),static_cast<int>(0x13d),0,"Unable to initialize class cache"},
{ static_cast<int>(0x8000400a),static_cast<int>(0x13d),0,"Unable to initialize RPC services"},
{ static_cast<int>(0x8000400b),static_cast<int>(0x13d),0,"Cannot set thread local storage channel control"},
{ static_cast<int>(0x8000400c),static_cast<int>(0x13d),0,"Could not allocate thread local storage channel control"},
{ static_cast<int>(0x8000400d),static_cast<int>(0x13d),0,"The user supplied memory allocator is unacceptable"},
{ static_cast<int>(0x8000400e),static_cast<int>(0x13d),0,"The OLE service mutex already exists"},
{ static_cast<int>(0x8000400f),static_cast<int>(0x13d),0,"The OLE service file mapping already exists"},
{ static_cast<int>(0x80004010),static_cast<int>(0x13d),0,"Unable to map view of file for OLE service"},
{ static_cast<int>(0x80004011),static_cast<int>(0x13d),0,"Failure attempting to launch OLE service"},
{ static_cast<int>(0x80004012),static_cast<int>(0x13d),0,"There was an attempt to call CoInitialize a second time while single threaded"},
{ static_cast<int>(0x80004013),static_cast<int>(0x13d),0,"A Remote activation was necessary but was not allowed"},
{ static_cast<int>(0x80004014),static_cast<int>(0x13d),0,"A Remote activation was necessary but the server name provided was invalid"},
{ static_cast<int>(0x80004015),static_cast<int>(0x13d),0,"The class is configured to run as a security id different from the caller"},
{ static_cast<int>(0x80004016),static_cast<int>(0x13d),0,"Use of Ole1 services requiring DDE windows is disabled"},
{ static_cast<int>(0x80004017),static_cast<int>(0x13d),0,"A RunAs specification must be <domain name>\\<user name> or simply <user name>"},
{ static_cast<int>(0x80004018),static_cast<int>(0x13d),0,"The server process could not be started. The pathname may be incorrect."},
{ static_cast<int>(0x80004019),static_cast<int>(0x13d),0,"The server process could not be started as the configured identity. The pathname may be incorrect or unavailable."},
{ static_cast<int>(0x8000401a),static_cast<int>(0x13d),0,"The server process could not be started because the configured identity is incorrect. Check the username and password."},
{ static_cast<int>(0x8000401b),static_cast<int>(0x13d),0,"The client is not allowed to launch this server."},
{ static_cast<int>(0x8000401c),static_cast<int>(0x13d),0,"The service providing this server could not be started."},
{ static_cast<int>(0x8000401d),static_cast<int>(0x13d),0,"This computer was unable to communicate with the computer providing the server."},
{ static_cast<int>(0x8000401e),static_cast<int>(0x13d),0,"The server did not respond after being launched."},
{ static_cast<int>(0x8000401f),static_cast<int>(0x13d),0,"The registration information for this server is inconsistent or incomplete."},
{ static_cast<int>(0x80004020),static_cast<int>(0x13d),0,"The registration information for this interface is inconsistent or incomplete."},
{ static_cast<int>(0x80004021),static_cast<int>(0x13d),0,"The operation attempted is not supported."},
{ static_cast<int>(0x80004022),static_cast<int>(0x13d),0,"A dll must be loaded."},
{ static_cast<int>(0x80004023),static_cast<int>(0x13d),0,"A Microsoft Software Installer error was encountered."},
{ static_cast<int>(0x80004024),static_cast<int>(0x13d),0,"The specified activation could not occur in the client context as specified."},
{ static_cast<int>(0x80004025),static_cast<int>(0x13d),0,"Activations on the server are paused."},
{ static_cast<int>(0x80004026),static_cast<int>(0x13d),0,"Activations on the server are not paused."},
{ static_cast<int>(0x80004027),static_cast<int>(0x13d),0,"The component or application containing the component has been disabled."},
{ static_cast<int>(0x80004028),static_cast<int>(0x13d),0,"The common language runtime is not available"},
{ static_cast<int>(0x80004029),static_cast<int>(0x13d),0,"The thread-pool rejected the submitted asynchronous work."},
{ static_cast<int>(0x8000402a),static_cast<int>(0x13d),0,"The server started, but did not finish initializing in a timely fashion."},
{ static_cast<int>(0x8000402b),static_cast<int>(0x13d),0,"Unable to complete the call since there is no COM+ security context inside IObjectControl.Activate."},
{ static_cast<int>(0x80004030),static_cast<int>(0x13d),0,"The provided tracker configuration is invalid"},
{ static_cast<int>(0x80004031),static_cast<int>(0x13d),0,"The provided thread pool configuration is invalid"},
{ static_cast<int>(0x80004032),static_cast<int>(0x13d),0,"The provided side-by-side configuration is invalid"},
{ static_cast<int>(0x80004033),static_cast<int>(0x13d),0,"The server principal name (SPN) obtained during security negotiation is malformed."},
{ static_cast<int>(0x80004034),static_cast<int>(0x13d),0,"The caller failed to revoke a per-apartment registration before apartment shutdown."},
{ static_cast<int>(0x80004035),static_cast<int>(0x13d),0,"The object has been rundown by the stub manager while there are external clients."},
{ static_cast<int>(0x8000a127),static_cast<int>(0x3bdf),0,"The interrupt requested to be unmasked is not masked."},
{ static_cast<int>(0x8000cf00),static_cast<int>(0x16e),0,"The Cloud File property blob is possibly corrupt. The on-disk checksum does not match the computed checksum."},
{ static_cast<int>(0x8000cf04),static_cast<int>(0x16d),0,"The operation could not be completed because the Cloud File property blob is too large."},
{ static_cast<int>(0x8000cf05),static_cast<int>(0x176),0,"The operation could not be completed because the maximum number of Cloud File property blobs would be exceeded."},
{ static_cast<int>(0xc0000001),static_cast<int>(0x1f),0,"{Operation Failed}\nThe requested operation was unsuccessful."},
{ static_cast<int>(0xc0000002),static_cast<int>(0x1),ENOSYS,"{Not Implemented}\nThe requested operation is not implemented."},
{ static_cast<int>(0xc0000003),static_cast<int>(0x57),0,"{Invalid Parameter}\nThe specified information class is not a valid information class for the specified object."},
{ static_cast<int>(0xc0000004),static_cast<int>(0x18),0,"The specified information record length does not match the length required for the specified information class."},
{ static_cast<int>(0xc0000005),static_cast<int>(0x3e6),EACCES,"The instruction at 0x%p referenced memory at 0x%p. The memory could not be %s."},
{ static_cast<int>(0xc0000006),static_cast<int>(0x3e7),0,"The instruction at 0x%p referenced memory at 0x%p. The required data was not placed into memory because of an I/O error status of 0x%x."},
{ static_cast<int>(0xc0000007),static_cast<int>(0x5ae),0,"The pagefile quota for the process has been exhausted."},
{ static_cast<int>(0xc0000008),static_cast<int>(0x6),EINVAL,"An invalid HANDLE was specified."},
{ static_cast<int>(0xc0000009),static_cast<int>(0x3e9),0,"An invalid initial stack was specified in a call to NtCreateThread."},
{ static_cast<int>(0xc000000a),static_cast<int>(0xc1),0,"An invalid initial start address was specified in a call to NtCreateThread."},
{ static_cast<int>(0xc000000b),static_cast<int>(0x57),0,"An invalid Client ID was specified."},
{ static_cast<int>(0xc000000c),static_cast<int>(0x21d),0,"An attempt was made to cancel or set a timer that has an associated APC and the subject thread is not the thread that originally set the timer with an associated APC routine."},
{ static_cast<int>(0xc000000d),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function."},
{ static_cast<int>(0xc000000e),static_cast<int>(0x2),ENOENT,"A device which does not exist was specified."},
{ static_cast<int>(0xc000000f),static_cast<int>(0x2),ENOENT,"{File Not Found}\nThe file %hs does not exist."},
{ static_cast<int>(0xc0000010),static_cast<int>(0x1),ENOSYS,"The specified request is not a valid operation for the target device."},
{ static_cast<int>(0xc0000011),static_cast<int>(0x26),0,"The end-of-file marker has been reached. There is no valid data in the file beyond this marker."},
{ static_cast<int>(0xc0000012),static_cast<int>(0x22),0,"{Wrong Volume}\nThe wrong volume is in the drive.\nPlease insert volume %hs into drive %hs."},
{ static_cast<int>(0xc0000013),static_cast<int>(0x15),EAGAIN,"{No Disk}\nThere is no disk in the drive.\nPlease insert a disk into drive %hs."},
{ static_cast<int>(0xc0000014),static_cast<int>(0x6f9),0,"{Unknown Disk Format}\nThe disk in drive %hs is not formatted properly.\nPlease check the disk, and reformat if necessary."},
{ static_cast<int>(0xc0000015),static_cast<int>(0x1b),0,"{Sector Not Found}\nThe specified sector does not exist."},
{ static_cast<int>(0xc0000016),static_cast<int>(0xea),0,"{Still Busy}\nThe specified I/O request packet (IRP) cannot be disposed of because the I/O operation is not complete."},
{ static_cast<int>(0xc0000017),static_cast<int>(0x8),ENOMEM,"{Not Enough Quota}\nNot enough virtual memory or paging file quota is available to complete the specified operation."},
{ static_cast<int>(0xc0000018),static_cast<int>(0x1e7),0,"{Conflicting Address Range}\nThe specified address range conflicts with the address space."},
{ static_cast<int>(0xc0000019),static_cast<int>(0x1e7),0,"Address range to unmap is not a mapped view."},
{ static_cast<int>(0xc000001a),static_cast<int>(0x57),0,"Virtual memory cannot be freed."},
{ static_cast<int>(0xc000001b),static_cast<int>(0x57),0,"Specified section cannot be deleted."},
{ static_cast<int>(0xc000001c),static_cast<int>(0x1),ENOSYS,"An invalid system service was specified in a system service call."},
{ static_cast<int>(0xc000001d),static_cast<int>(0x0),0,"{EXCEPTION}\nIllegal Instruction\nAn attempt was made to execute an illegal instruction."},
{ static_cast<int>(0xc000001e),static_cast<int>(0x5),EACCES,"{Invalid Lock Sequence}\nAn attempt was made to execute an invalid lock sequence."},
{ static_cast<int>(0xc000001f),static_cast<int>(0x5),EACCES,"{Invalid Mapping}\nAn attempt was made to create a view for a section which is bigger than the section."},
{ static_cast<int>(0xc0000020),static_cast<int>(0xc1),0,"{Bad File}\nThe attributes of the specified mapping file for a section of memory cannot be read."},
{ static_cast<int>(0xc0000021),static_cast<int>(0x5),EACCES,"{Already Committed}\nThe specified address range is already committed."},
{ static_cast<int>(0xc0000022),static_cast<int>(0x5),EACCES,"{Access Denied}\nA process has requested access to an object, but has not been granted those access rights."},
{ static_cast<int>(0xc0000023),static_cast<int>(0x7a),0,"{Buffer Too Small}\nThe buffer is too small to contain the entry. No information has been written to the buffer."},
{ static_cast<int>(0xc0000024),static_cast<int>(0x6),EINVAL,"{Wrong Type}\nThere is a mismatch between the type of object required by the requested operation and the type of object that is specified in the request."},
{ static_cast<int>(0xc0000025),static_cast<int>(0x0),0,"{EXCEPTION}\nCannot Continue\nWindows cannot continue from this exception."},
{ static_cast<int>(0xc0000026),static_cast<int>(0x0),0,"An invalid exception disposition was returned by an exception handler."},
{ static_cast<int>(0xc0000027),static_cast<int>(0x21e),0,"Unwind exception code."},
{ static_cast<int>(0xc0000028),static_cast<int>(0x21f),0,"An invalid or unaligned stack was encountered during an unwind operation."},
{ static_cast<int>(0xc0000029),static_cast<int>(0x220),0,"An invalid unwind target was encountered during an unwind operation."},
{ static_cast<int>(0xc000002a),static_cast<int>(0x9e),0,"An attempt was made to unlock a page of memory which was not locked."},
{ static_cast<int>(0xc000002b),static_cast<int>(0x0),0,"Device parity error on I/O operation."},
{ static_cast<int>(0xc000002c),static_cast<int>(0x1e7),0,"An attempt was made to decommit uncommitted virtual memory."},
{ static_cast<int>(0xc000002d),static_cast<int>(0x1e7),0,"An attempt was made to change the attributes on memory that has not been committed."},
{ static_cast<int>(0xc000002e),static_cast<int>(0x221),0,"Invalid Object Attributes specified to NtCreatePort or invalid Port Attributes specified to NtConnectPort"},
{ static_cast<int>(0xc000002f),static_cast<int>(0x222),0,"Length of message passed to NtRequestPort or NtRequestWaitReplyPort was longer than the maximum message allowed by the port."},
{ static_cast<int>(0xc0000030),static_cast<int>(0x57),0,"An invalid combination of parameters was specified."},
{ static_cast<int>(0xc0000031),static_cast<int>(0x223),0,"An attempt was made to lower a quota limit below the current usage."},
{ static_cast<int>(0xc0000032),static_cast<int>(0x571),0,"{Corrupt Disk}\nThe file system structure on the disk is corrupt and unusable.\nPlease run the Chkdsk utility on the volume %hs."},
{ static_cast<int>(0xc0000033),static_cast<int>(0x7b),EINVAL,"Object Name invalid."},
{ static_cast<int>(0xc0000034),static_cast<int>(0x2),ENOENT,"Object Name not found."},
{ static_cast<int>(0xc0000035),static_cast<int>(0xb7),EEXIST,"Object Name already exists."},
{ static_cast<int>(0xc0000036),static_cast<int>(0x72a),0,"A port with the 'do not disturb' flag set attempted to send a message to a port in a suspended process.\nThe process was not woken, and the message was not delivered."},
{ static_cast<int>(0xc0000037),static_cast<int>(0x6),EINVAL,"Attempt to send a message to a disconnected communication port."},
{ static_cast<int>(0xc0000038),static_cast<int>(0x224),0,"An attempt was made to attach to a device that was already attached to another device."},
{ static_cast<int>(0xc0000039),static_cast<int>(0xa1),0,"Object Path Component was not a directory object."},
{ static_cast<int>(0xc000003a),static_cast<int>(0x3),ENOENT,"{Path Not Found}\nThe path %hs does not exist."},
{ static_cast<int>(0xc000003b),static_cast<int>(0xa1),0,"Object Path Component was not a directory object."},
{ static_cast<int>(0xc000003c),static_cast<int>(0x45d),0,"{Data Overrun}\nA data overrun error occurred."},
{ static_cast<int>(0xc000003d),static_cast<int>(0x45d),0,"{Data Late}\nA data late error occurred."},
{ static_cast<int>(0xc000003e),static_cast<int>(0x17),0,"{Data Error}\nAn error in reading or writing data occurred."},
{ static_cast<int>(0xc000003f),static_cast<int>(0x17),0,"{Bad CRC}\nA cyclic redundancy check (CRC) checksum error occurred."},
{ static_cast<int>(0xc0000040),static_cast<int>(0x8),ENOMEM,"{Section Too Large}\nThe specified section is too big to map the file."},
{ static_cast<int>(0xc0000041),static_cast<int>(0x5),EACCES,"The NtConnectPort request is refused."},
{ static_cast<int>(0xc0000042),static_cast<int>(0x6),EINVAL,"The type of port handle is invalid for the operation requested."},
{ static_cast<int>(0xc0000043),static_cast<int>(0x20),EACCES,"A file cannot be opened because the share access flags are incompatible."},
{ static_cast<int>(0xc0000044),static_cast<int>(0x718),0,"Insufficient quota exists to complete the operation"},
{ static_cast<int>(0xc0000045),static_cast<int>(0x57),0,"The specified page protection was not valid."},
{ static_cast<int>(0xc0000046),static_cast<int>(0x120),0,"An attempt to release a mutant object was made by a thread that was not the owner of the mutant object."},
{ static_cast<int>(0xc0000047),static_cast<int>(0x12a),0,"An attempt was made to release a semaphore such that its maximum count would have been exceeded."},
{ static_cast<int>(0xc0000048),static_cast<int>(0x57),0,"An attempt to set a process's DebugPort or ExceptionPort was made, but a port already exists in the process or an attempt to set a file's CompletionPort made, but a port was already set in the file or an attempt to set an ALPC port's associated completion port was made, but it is already set."},
{ static_cast<int>(0xc0000049),static_cast<int>(0x57),0,"An attempt was made to query image information on a section which does not map an image."},
{ static_cast<int>(0xc000004a),static_cast<int>(0x9c),0,"An attempt was made to suspend a thread whose suspend count was at its maximum."},
{ static_cast<int>(0xc000004b),static_cast<int>(0x5),EACCES,"An attempt was made to access a thread that has begun termination."},
{ static_cast<int>(0xc000004c),static_cast<int>(0x57),0,"An attempt was made to set the working set limit to an invalid value (minimum greater than maximum, etc)."},
{ static_cast<int>(0xc000004d),static_cast<int>(0x57),0,"A section was created to map a file which is not compatible to an already existing section which maps the same file."},
{ static_cast<int>(0xc000004e),static_cast<int>(0x57),0,"A view to a section specifies a protection which is incompatible with the initial view's protection."},
{ static_cast<int>(0xc000004f),static_cast<int>(0x11a),0,"An operation involving EAs failed because the file system does not support EAs."},
{ static_cast<int>(0xc0000050),static_cast<int>(0xff),0,"An EA operation failed because EA set is too large."},
{ static_cast<int>(0xc0000051),static_cast<int>(0x570),0,"An EA operation failed because the name or EA index is invalid."},
{ static_cast<int>(0xc0000052),static_cast<int>(0x570),0,"The file for which EAs were requested has no EAs."},
{ static_cast<int>(0xc0000053),static_cast<int>(0x570),0,"The EA is corrupt and non-readable."},
{ static_cast<int>(0xc0000054),static_cast<int>(0x21),ENOLCK,"A requested read/write cannot be granted due to a conflicting file lock."},
{ static_cast<int>(0xc0000055),static_cast<int>(0x21),ENOLCK,"A requested file lock cannot be granted due to other existing locks."},
{ static_cast<int>(0xc0000056),static_cast<int>(0x5),EACCES,"A non close operation has been requested of a file object with a delete pending."},
{ static_cast<int>(0xc0000057),static_cast<int>(0x32),0,"An attempt was made to set the control attribute on a file. This attribute is not supported in the target file system."},
{ static_cast<int>(0xc0000058),static_cast<int>(0x519),0,"Indicates a revision number encountered or specified is not one known by the service. It may be a more recent revision than the service is aware of."},
{ static_cast<int>(0xc0000059),static_cast<int>(0x51a),0,"Indicates two revision levels are incompatible."},
{ static_cast<int>(0xc000005a),static_cast<int>(0x51b),0,"Indicates a particular Security ID may not be assigned as the owner of an object."},
{ static_cast<int>(0xc000005b),static_cast<int>(0x51c),0,"Indicates a particular Security ID may not be assigned as the primary group of an object."},
{ static_cast<int>(0xc000005c),static_cast<int>(0x51d),0,"An attempt has been made to operate on an impersonation token by a thread that is not currently impersonating a client."},
{ static_cast<int>(0xc000005d),static_cast<int>(0x51e),0,"A mandatory group may not be disabled."},
{ static_cast<int>(0xc000005e),static_cast<int>(0x51f),0,"We can't sign you in with this credential because your domain isn't available. Make sure your device is connected to your organization's network and try again. If you previously signed in on this device with another credential, you can sign in with that credential."},
{ static_cast<int>(0xc000005f),static_cast<int>(0x520),0,"A specified logon session does not exist. It may already have been terminated."},
{ static_cast<int>(0xc0000060),static_cast<int>(0x521),0,"A specified privilege does not exist."},
{ static_cast<int>(0xc0000061),static_cast<int>(0x522),0,"A required privilege is not held by the client."},
{ static_cast<int>(0xc0000062),static_cast<int>(0x523),0,"The name provided is not a properly formed account name."},
{ static_cast<int>(0xc0000063),static_cast<int>(0x524),0,"The specified account already exists."},
{ static_cast<int>(0xc0000064),static_cast<int>(0x525),0,"The specified account does not exist."},
{ static_cast<int>(0xc0000065),static_cast<int>(0x526),0,"The specified group already exists."},
{ static_cast<int>(0xc0000066),static_cast<int>(0x527),0,"The specified group does not exist."},
{ static_cast<int>(0xc0000067),static_cast<int>(0x528),0,"The specified user account is already in the specified group account. Also used to indicate a group cannot be deleted because it contains a member."},
{ static_cast<int>(0xc0000068),static_cast<int>(0x529),0,"The specified user account is not a member of the specified group account."},
{ static_cast<int>(0xc0000069),static_cast<int>(0x52a),0,"Indicates the requested operation would disable, delete or could prevent logon for an administration account.\nThis is not allowed to prevent creating a situation in which the system cannot be administrated."},
{ static_cast<int>(0xc000006a),static_cast<int>(0x56),0,"When trying to update a password, this return status indicates that the value provided as the current password is not correct."},
{ static_cast<int>(0xc000006b),static_cast<int>(0x52c),0,"When trying to update a password, this return status indicates that the value provided for the new password contains values that are not allowed in passwords."},
{ static_cast<int>(0xc000006c),static_cast<int>(0x52d),0,"When trying to update a password, this status indicates that some password update rule has been violated. For example, the password may not meet length criteria."},
{ static_cast<int>(0xc000006d),static_cast<int>(0x52e),0,"The attempted logon is invalid. This is either due to a bad username or authentication information."},
{ static_cast<int>(0xc000006e),static_cast<int>(0x52f),0,"Indicates a referenced user name and authentication information are valid, but some user account restriction has prevented successful authentication (such as time-of-day restrictions)."},
{ static_cast<int>(0xc000006f),static_cast<int>(0x530),0,"The user account has time restrictions and may not be logged onto at this time."},
{ static_cast<int>(0xc0000070),static_cast<int>(0x531),0,"The user account is restricted such that it may not be used to log on from the source workstation."},
{ static_cast<int>(0xc0000071),static_cast<int>(0x532),0,"The user account's password has expired."},
{ static_cast<int>(0xc0000072),static_cast<int>(0x533),0,"The referenced account is currently disabled and may not be logged on to."},
{ static_cast<int>(0xc0000073),static_cast<int>(0x534),0,"None of the information to be translated has been translated."},
{ static_cast<int>(0xc0000074),static_cast<int>(0x535),0,"The number of LUIDs requested may not be allocated with a single allocation."},
{ static_cast<int>(0xc0000075),static_cast<int>(0x536),0,"Indicates there are no more LUIDs to allocate."},
{ static_cast<int>(0xc0000076),static_cast<int>(0x537),0,"Indicates the sub-authority value is invalid for the particular use."},
{ static_cast<int>(0xc0000077),static_cast<int>(0x538),0,"Indicates the ACL structure is not valid."},
{ static_cast<int>(0xc0000078),static_cast<int>(0x539),0,"Indicates the SID structure is not valid."},
{ static_cast<int>(0xc0000079),static_cast<int>(0x53a),0,"Indicates the SECURITY_DESCRIPTOR structure is not valid."},
{ static_cast<int>(0xc000007a),static_cast<int>(0x7f),0,"Indicates the specified procedure address cannot be found in the DLL."},
{ static_cast<int>(0xc000007b),static_cast<int>(0xc1),0,"{Bad Image}\n%hs is either not designed to run on Windows or it contains an error. Try installing the program again using the original installation media or contact your system administrator or the software vendor for support. Error status 0x"},
{ static_cast<int>(0xc000007c),static_cast<int>(0x3f0),0,"An attempt was made to reference a token that doesn't exist.\nThis is typically done by referencing the token associated with a thread when the thread is not impersonating a client."},
{ static_cast<int>(0xc000007d),static_cast<int>(0x53c),0,"Indicates that an attempt to build either an inherited ACL or ACE was not successful.\nThis can be caused by a number of things. One of the more probable causes is the replacement of a CreatorId with an SID that didn't fit into the ACE or ACL."},
{ static_cast<int>(0xc000007e),static_cast<int>(0x9e),0,"The range specified in NtUnlockFile was not locked."},
{ static_cast<int>(0xc000007f),static_cast<int>(0x70),ENOSPC,"An operation failed because the disk was full.\nIf this is a thinly provisioned volume the physical storage backing this volume has been exhausted."},
{ static_cast<int>(0xc0000080),static_cast<int>(0x53d),0,"The GUID allocation server is [already] disabled at the moment."},
{ static_cast<int>(0xc0000081),static_cast<int>(0x53e),0,"The GUID allocation server is [already] enabled at the moment."},
{ static_cast<int>(0xc0000082),static_cast<int>(0x44),0,"Too many GUIDs were requested from the allocation server at once."},
{ static_cast<int>(0xc0000083),static_cast<int>(0x103),0,"The GUIDs could not be allocated because the Authority Agent was exhausted."},
{ static_cast<int>(0xc0000084),static_cast<int>(0x53f),0,"The value provided was an invalid value for an identifier authority."},
{ static_cast<int>(0xc0000085),static_cast<int>(0x103),0,"There are no more authority agent values available for the given identifier authority value."},
{ static_cast<int>(0xc0000086),static_cast<int>(0x9a),0,"An invalid volume label has been specified."},
{ static_cast<int>(0xc0000087),static_cast<int>(0xe),ENOMEM,"A mapped section could not be extended."},
{ static_cast<int>(0xc0000088),static_cast<int>(0x1e7),0,"Specified section to flush does not map a data file."},
{ static_cast<int>(0xc0000089),static_cast<int>(0x714),0,"Indicates the specified image file did not contain a resource section."},
{ static_cast<int>(0xc000008a),static_cast<int>(0x715),0,"Indicates the specified resource type cannot be found in the image file."},
{ static_cast<int>(0xc000008b),static_cast<int>(0x716),0,"Indicates the specified resource name cannot be found in the image file."},
{ static_cast<int>(0xc000008c),static_cast<int>(0x0),0,"{EXCEPTION}\nArray bounds exceeded."},
{ static_cast<int>(0xc000008d),static_cast<int>(0x0),0,"{EXCEPTION}\nFloating-point denormal operand."},
{ static_cast<int>(0xc000008e),static_cast<int>(0x0),0,"{EXCEPTION}\nFloating-point division by zero."},
{ static_cast<int>(0xc000008f),static_cast<int>(0x0),0,"{EXCEPTION}\nFloating-point inexact result."},
{ static_cast<int>(0xc0000090),static_cast<int>(0x0),0,"{EXCEPTION}\nFloating-point invalid operation."},
{ static_cast<int>(0xc0000091),static_cast<int>(0x0),0,"{EXCEPTION}\nFloating-point overflow."},
{ static_cast<int>(0xc0000092),static_cast<int>(0x0),0,"{EXCEPTION}\nFloating-point stack check."},
{ static_cast<int>(0xc0000093),static_cast<int>(0x0),0,"{EXCEPTION}\nFloating-point underflow."},
{ static_cast<int>(0xc0000094),static_cast<int>(0x0),0,"{EXCEPTION}\nInteger division by zero."},
{ static_cast<int>(0xc0000095),static_cast<int>(0x216),0,"{EXCEPTION}\nInteger overflow."},
{ static_cast<int>(0xc0000096),static_cast<int>(0x0),0,"{EXCEPTION}\nPrivileged instruction."},
{ static_cast<int>(0xc0000097),static_cast<int>(0x8),ENOMEM,"An attempt was made to install more paging files than the system supports."},
{ static_cast<int>(0xc0000098),static_cast<int>(0x3ee),0,"The volume for a file has been externally altered such that the opened file is no longer valid."},
{ static_cast<int>(0xc0000099),static_cast<int>(0x540),0,"When a block of memory is allotted for future updates, such as the memory allocated to hold discretionary access control and primary group information, successive updates may exceed the amount of memory originally allotted.\nSince quota may already have been charged to several processes which have handles to the object, it is not reasonable to alter the size of the allocated memory.\nInstead, a request that requires more memory than has been allotted must fail and the STATUS_ALLOTED_SPACE_EXCEEDED error returned."},
{ static_cast<int>(0xc000009a),static_cast<int>(0x5aa),0,"Insufficient system resources exist to complete the API."},
{ static_cast<int>(0xc000009b),static_cast<int>(0x3),ENOENT,"An attempt has been made to open a DFS exit path control file."},
{ static_cast<int>(0xc000009c),static_cast<int>(0x17),0,"STATUS_DEVICE_DATA_ERROR"},
{ static_cast<int>(0xc000009d),static_cast<int>(0x48f),0,"STATUS_DEVICE_NOT_CONNECTED"},
{ static_cast<int>(0xc000009e),static_cast<int>(0x15),EAGAIN,"STATUS_DEVICE_POWER_FAILURE"},
{ static_cast<int>(0xc000009f),static_cast<int>(0x1e7),0,"Virtual memory cannot be freed as base address is not the base of the region and a region size of zero was specified."},
{ static_cast<int>(0xc00000a0),static_cast<int>(0x1e7),0,"An attempt was made to free virtual memory which is not allocated."},
{ static_cast<int>(0xc00000a1),static_cast<int>(0x5ad),0,"The working set is not big enough to allow the requested pages to be locked."},
{ static_cast<int>(0xc00000a2),static_cast<int>(0x13),EACCES,"{Write Protect Error}\nThe disk cannot be written to because it is write protected. Please remove the write protection from the volume %hs in drive %hs."},
{ static_cast<int>(0xc00000a3),static_cast<int>(0x15),EAGAIN,"{Drive Not Ready}\nThe drive is not ready for use; its door may be open. Please check drive %hs and make sure that a disk is inserted and that the drive door is closed."},
{ static_cast<int>(0xc00000a4),static_cast<int>(0x541),0,"The specified attributes are invalid, or incompatible with the attributes for the group as a whole."},
{ static_cast<int>(0xc00000a5),static_cast<int>(0x542),0,"A specified impersonation level is invalid.\nAlso used to indicate a required impersonation level was not provided."},
{ static_cast<int>(0xc00000a6),static_cast<int>(0x543),0,"An attempt was made to open an Anonymous level token.\nAnonymous tokens may not be opened."},
{ static_cast<int>(0xc00000a7),static_cast<int>(0x544),0,"The validation information class requested was invalid."},
{ static_cast<int>(0xc00000a8),static_cast<int>(0x545),0,"The type of a token object is inappropriate for its attempted use."},
{ static_cast<int>(0xc00000a9),static_cast<int>(0x57),0,"The type of a token object is inappropriate for its attempted use."},
{ static_cast<int>(0xc00000aa),static_cast<int>(0x225),0,"An attempt was made to execute an instruction at an unaligned address and the host system does not support unaligned instruction references."},
{ static_cast<int>(0xc00000ab),static_cast<int>(0xe7),0,"The maximum named pipe instance count has been reached."},
{ static_cast<int>(0xc00000ac),static_cast<int>(0xe7),0,"An instance of a named pipe cannot be found in the listening state."},
{ static_cast<int>(0xc00000ad),static_cast<int>(0xe6),0,"The named pipe is not in the connected or closing state."},
{ static_cast<int>(0xc00000ae),static_cast<int>(0xe7),0,"The specified pipe is set to complete operations and there are current I/O operations queued so it cannot be changed to queue operations."},
{ static_cast<int>(0xc00000af),static_cast<int>(0x1),ENOSYS,"The specified handle is not open to the server end of the named pipe."},
{ static_cast<int>(0xc00000b0),static_cast<int>(0xe9),0,"The specified named pipe is in the disconnected state."},
{ static_cast<int>(0xc00000b1),static_cast<int>(0xe8),0,"The specified named pipe is in the closing state."},
{ static_cast<int>(0xc00000b2),static_cast<int>(0x217),0,"The specified named pipe is in the connected state."},
{ static_cast<int>(0xc00000b3),static_cast<int>(0x218),0,"The specified named pipe is in the listening state."},
{ static_cast<int>(0xc00000b4),static_cast<int>(0xe6),0,"The specified named pipe is not in message mode."},
{ static_cast<int>(0xc00000b5),static_cast<int>(0x79),0,"{Device Timeout}\nThe specified I/O operation on %hs was not completed before the time-out period expired."},
{ static_cast<int>(0xc00000b6),static_cast<int>(0x26),0,"The specified file has been closed by another process."},
{ static_cast<int>(0xc00000b7),static_cast<int>(0x226),0,"Profiling not started."},
{ static_cast<int>(0xc00000b8),static_cast<int>(0x227),0,"Profiling not stopped."},
{ static_cast<int>(0xc00000b9),static_cast<int>(0x228),0,"The passed ACL did not contain the minimum required information."},
{ static_cast<int>(0xc00000ba),static_cast<int>(0x5),EACCES,"The file that was specified as a target is a directory and the caller specified that it could be anything but a directory."},
{ static_cast<int>(0xc00000bb),static_cast<int>(0x32),0,"The request is not supported."},
{ static_cast<int>(0xc00000bc),static_cast<int>(0x33),0,"This remote computer is not listening."},
{ static_cast<int>(0xc00000bd),static_cast<int>(0x34),0,"A duplicate name exists on the network."},
{ static_cast<int>(0xc00000be),static_cast<int>(0x35),0,"The network path cannot be located."},
{ static_cast<int>(0xc00000bf),static_cast<int>(0x36),0,"The network is busy."},
{ static_cast<int>(0xc00000c0),static_cast<int>(0x37),ENODEV,"This device does not exist."},
{ static_cast<int>(0xc00000c1),static_cast<int>(0x38),0,"The network BIOS command limit has been reached."},
{ static_cast<int>(0xc00000c2),static_cast<int>(0x39),0,"An I/O adapter hardware error has occurred."},
{ static_cast<int>(0xc00000c3),static_cast<int>(0x3a),0,"The network responded incorrectly."},
{ static_cast<int>(0xc00000c4),static_cast<int>(0x3b),0,"An unexpected network error occurred."},
{ static_cast<int>(0xc00000c5),static_cast<int>(0x3c),0,"The remote adapter is not compatible."},
{ static_cast<int>(0xc00000c6),static_cast<int>(0x3d),0,"The printer queue is full."},
{ static_cast<int>(0xc00000c7),static_cast<int>(0x3e),0,"Space to store the file waiting to be printed is not available on the server."},
{ static_cast<int>(0xc00000c8),static_cast<int>(0x3f),0,"The requested print file has been canceled."},
{ static_cast<int>(0xc00000c9),static_cast<int>(0x40),0,"The network name was deleted."},
{ static_cast<int>(0xc00000ca),static_cast<int>(0x41),0,"Network access is denied."},
{ static_cast<int>(0xc00000cb),static_cast<int>(0x42),0,"{Incorrect Network Resource Type}\nThe specified device type (LPT, for example) conflicts with the actual device type on the remote resource."},
{ static_cast<int>(0xc00000cc),static_cast<int>(0x43),0,"{Network Name Not Found}\nThe specified share name cannot be found on the remote server."},
{ static_cast<int>(0xc00000cd),static_cast<int>(0x44),0,"The name limit for the local computer network adapter card was exceeded."},
{ static_cast<int>(0xc00000ce),static_cast<int>(0x45),0,"The network BIOS session limit was exceeded."},
{ static_cast<int>(0xc00000cf),static_cast<int>(0x46),0,"File sharing has been temporarily paused."},
{ static_cast<int>(0xc00000d0),static_cast<int>(0x47),0,"No more connections can be made to this remote computer at this time because there are already as many connections as the computer can accept."},
{ static_cast<int>(0xc00000d1),static_cast<int>(0x48),0,"Print or disk redirection is temporarily paused."},
{ static_cast<int>(0xc00000d2),static_cast<int>(0x58),0,"A network data fault occurred."},
{ static_cast<int>(0xc00000d3),static_cast<int>(0x229),0,"The number of active profiling objects is at the maximum and no more may be started."},
{ static_cast<int>(0xc00000d4),static_cast<int>(0x11),EXDEV,"{Incorrect Volume}\nThe target file of a rename request is located on a different device than the source of the rename request."},
{ static_cast<int>(0xc00000d5),static_cast<int>(0x5),EACCES,"The file specified has been renamed and thus cannot be modified."},
{ static_cast<int>(0xc00000d6),static_cast<int>(0xf0),0,"{Network Request Timeout}\nThe session with a remote server has been disconnected because the time-out interval for a request has expired."},
{ static_cast<int>(0xc00000d7),static_cast<int>(0x546),0,"Indicates an attempt was made to operate on the security of an object that does not have security associated with it."},
{ static_cast<int>(0xc00000d8),static_cast<int>(0x22a),0,"Used to indicate that an operation cannot continue without blocking for I/O."},
{ static_cast<int>(0xc00000d9),static_cast<int>(0xe8),0,"Used to indicate that a read operation was done on an empty pipe."},
{ static_cast<int>(0xc00000da),static_cast<int>(0x547),0,"Configuration information could not be read from the domain controller, either because the machine is unavailable, or access has been denied."},
{ static_cast<int>(0xc00000db),static_cast<int>(0x22b),0,"Indicates that a thread attempted to terminate itself by default (called NtTerminateThread with NULL) and it was the last thread in the current process."},
{ static_cast<int>(0xc00000dc),static_cast<int>(0x548),0,"Indicates the Sam Server was in the wrong state to perform the desired operation."},
{ static_cast<int>(0xc00000dd),static_cast<int>(0x549),0,"Indicates the Domain was in the wrong state to perform the desired operation."},
{ static_cast<int>(0xc00000de),static_cast<int>(0x54a),0,"This operation is only allowed for the Primary Domain Controller of the domain."},
{ static_cast<int>(0xc00000df),static_cast<int>(0x54b),0,"The specified Domain did not exist."},
{ static_cast<int>(0xc00000e0),static_cast<int>(0x54c),0,"The specified Domain already exists."},
{ static_cast<int>(0xc00000e1),static_cast<int>(0x54d),0,"An attempt was made to exceed the limit on the number of domains per server for this release."},
{ static_cast<int>(0xc00000e2),static_cast<int>(0x12c),0,"Error status returned when oplock request is denied."},
{ static_cast<int>(0xc00000e3),static_cast<int>(0x12d),0,"Error status returned when an invalid oplock acknowledgment is received by a file system."},
{ static_cast<int>(0xc00000e4),static_cast<int>(0x54e),0,"This error indicates that the requested operation cannot be completed due to a catastrophic media failure or on-disk data structure corruption."},
{ static_cast<int>(0xc00000e5),static_cast<int>(0x54f),0,"An internal error occurred."},
{ static_cast<int>(0xc00000e6),static_cast<int>(0x550),0,"Indicates generic access types were contained in an access mask which should already be mapped to non-generic access types."},
{ static_cast<int>(0xc00000e7),static_cast<int>(0x551),0,"Indicates a security descriptor is not in the necessary format (absolute or self-relative)."},
{ static_cast<int>(0xc00000e8),static_cast<int>(0x6f8),0,"An access to a user buffer failed at an \"expected\" point in time. This code is defined since the caller does not want to accept STATUS_ACCESS_VIOLATION in its filter."},
{ static_cast<int>(0xc00000e9),static_cast<int>(0x45d),0,"If an I/O error is returned which is not defined in the standard FsRtl filter, it is converted to the following error which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception."},
{ static_cast<int>(0xc00000ea),static_cast<int>(0x22c),0,"If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception."},
{ static_cast<int>(0xc00000eb),static_cast<int>(0x22d),0,"If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception."},
{ static_cast<int>(0xc00000ec),static_cast<int>(0x22e),0,"If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter. In this case information is lost, however, the filter correctly handles the exception."},
{ static_cast<int>(0xc00000ed),static_cast<int>(0x552),0,"The requested action is restricted for use by logon processes only. The calling process has not registered as a logon process."},
{ static_cast<int>(0xc00000ee),static_cast<int>(0x553),0,"An attempt has been made to start a new session manager or LSA logon session with an ID that is already in use."},
{ static_cast<int>(0xc00000ef),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the first argument."},
{ static_cast<int>(0xc00000f0),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the second argument."},
{ static_cast<int>(0xc00000f1),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the third argument."},
{ static_cast<int>(0xc00000f2),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the fourth argument."},
{ static_cast<int>(0xc00000f3),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the fifth argument."},
{ static_cast<int>(0xc00000f4),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the sixth argument."},
{ static_cast<int>(0xc00000f5),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the seventh argument."},
{ static_cast<int>(0xc00000f6),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the eighth argument."},
{ static_cast<int>(0xc00000f7),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the ninth argument."},
{ static_cast<int>(0xc00000f8),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the tenth argument."},
{ static_cast<int>(0xc00000f9),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the eleventh argument."},
{ static_cast<int>(0xc00000fa),static_cast<int>(0x57),0,"An invalid parameter was passed to a service or function as the twelfth argument."},
{ static_cast<int>(0xc00000fb),static_cast<int>(0x3),ENOENT,"An attempt was made to access a network file, but the network software was not yet started."},
{ static_cast<int>(0xc00000fc),static_cast<int>(0x420),0,"An attempt was made to start the redirector, but the redirector has already been started."},
{ static_cast<int>(0xc00000fd),static_cast<int>(0x3e9),0,"A new guard page for the stack cannot be created."},
{ static_cast<int>(0xc00000fe),static_cast<int>(0x554),0,"A specified authentication package is unknown."},
{ static_cast<int>(0xc00000ff),static_cast<int>(0x22f),0,"A malformed function table was encountered during an unwind operation."},
{ static_cast<int>(0xc0000100),static_cast<int>(0xcb),0,"Indicates the specified environment variable name was not found in the specified environment block."},
{ static_cast<int>(0xc0000101),static_cast<int>(0x91),ENOTEMPTY,"Indicates that the directory trying to be deleted is not empty."},
{ static_cast<int>(0xc0000102),static_cast<int>(0x570),0,"{Corrupt File}\nThe file or directory %hs is corrupt and unreadable.\nPlease run the Chkdsk utility."},
{ static_cast<int>(0xc0000103),static_cast<int>(0x10b),EINVAL,"A requested opened file is not a directory."},
{ static_cast<int>(0xc0000104),static_cast<int>(0x555),0,"The logon session is not in a state that is consistent with the requested operation."},
{ static_cast<int>(0xc0000105),static_cast<int>(0x556),0,"An internal LSA error has occurred. An authentication package has requested the creation of a Logon Session but the ID of an already existing Logon Session has been specified."},
{ static_cast<int>(0xc0000106),static_cast<int>(0xce),0,"A specified name string is too long for its intended use."},
{ static_cast<int>(0xc0000107),static_cast<int>(0x961),EBUSY,"The user attempted to force close the files on a redirected drive, but there were opened files on the drive, and the user did not specify a sufficient level of force."},
{ static_cast<int>(0xc0000108),static_cast<int>(0x964),EBUSY,"The user attempted to force close the files on a redirected drive, but there were opened directories on the drive, and the user did not specify a sufficient level of force."},
{ static_cast<int>(0xc0000109),static_cast<int>(0x13d),0,"RtlFindMessage could not locate the requested message ID in the message table resource."},
{ static_cast<int>(0xc000010a),static_cast<int>(0x5),EACCES,"An attempt was made to access an exiting process."},
{ static_cast<int>(0xc000010b),static_cast<int>(0x557),0,"Indicates an invalid value has been provided for the LogonType requested."},
{ static_cast<int>(0xc000010c),static_cast<int>(0x230),0,"Indicates that an attempt was made to assign protection to a file system file or directory and one of the SIDs in the security descriptor could not be translated into a GUID that could be stored by the file system.\nThis causes the protection attempt to fail, which may cause a file creation attempt to fail."},
{ static_cast<int>(0xc000010d),static_cast<int>(0x558),0,"Indicates that an attempt has been made to impersonate via a named pipe that has not yet been read from."},
{ static_cast<int>(0xc000010e),static_cast<int>(0x420),0,"Indicates that the specified image is already loaded."},
{ static_cast<int>(0xc000010f),static_cast<int>(0x21a),0,"STATUS_ABIOS_NOT_PRESENT"},
{ static_cast<int>(0xc0000110),static_cast<int>(0x21a),0,"STATUS_ABIOS_LID_NOT_EXIST"},
{ static_cast<int>(0xc0000111),static_cast<int>(0x21a),0,"STATUS_ABIOS_LID_ALREADY_OWNED"},
{ static_cast<int>(0xc0000112),static_cast<int>(0x21a),0,"STATUS_ABIOS_NOT_LID_OWNER"},
{ static_cast<int>(0xc0000113),static_cast<int>(0x21a),0,"STATUS_ABIOS_INVALID_COMMAND"},
{ static_cast<int>(0xc0000114),static_cast<int>(0x21a),0,"STATUS_ABIOS_INVALID_LID"},
{ static_cast<int>(0xc0000115),static_cast<int>(0x21a),0,"STATUS_ABIOS_SELECTOR_NOT_AVAILABLE"},
{ static_cast<int>(0xc0000116),static_cast<int>(0x21a),0,"STATUS_ABIOS_INVALID_SELECTOR"},
{ static_cast<int>(0xc0000117),static_cast<int>(0x5a4),0,"Indicates that an attempt was made to change the size of the LDT for a process that has no LDT."},
{ static_cast<int>(0xc0000118),static_cast<int>(0x231),0,"Indicates that an attempt was made to grow an LDT by setting its size, or that the size was not an even number of selectors."},
{ static_cast<int>(0xc0000119),static_cast<int>(0x233),0,"Indicates that the starting value for the LDT information was not an integral multiple of the selector size."},
{ static_cast<int>(0xc000011a),static_cast<int>(0x234),0,"Indicates that the user supplied an invalid descriptor when trying to set up Ldt descriptors."},
{ static_cast<int>(0xc000011b),static_cast<int>(0xc1),0,"The specified image file did not have the correct format. It appears to be NE format."},
{ static_cast<int>(0xc000011c),static_cast<int>(0x559),0,"Indicates that the transaction state of a registry sub-tree is incompatible with the requested operation. For example, a request has been made to start a new transaction with one already in progress, or a request has been made to apply a transaction when one is not currently in progress."},
{ static_cast<int>(0xc000011d),static_cast<int>(0x55a),0,"Indicates an error has occurred during a registry transaction commit. The database has been left in an unknown, but probably inconsistent, state. The state of the registry transaction is left as COMMITTING."},
{ static_cast<int>(0xc000011e),static_cast<int>(0x3ee),0,"An attempt was made to map a file of size zero with the maximum size specified as zero."},
{ static_cast<int>(0xc000011f),static_cast<int>(0x4),EMFILE,"Too many files are opened on a remote server.\nThis error should only be returned by the Windows redirector on a remote drive."},
{ static_cast<int>(0xc0000120),static_cast<int>(0x3e3),ECANCELED,"The I/O request was canceled."},
{ static_cast<int>(0xc0000121),static_cast<int>(0x5),EACCES,"An attempt has been made to remove a file or directory that cannot be deleted."},
{ static_cast<int>(0xc0000122),static_cast<int>(0x4ba),0,"Indicates a name specified as a remote computer name is syntactically invalid."},
{ static_cast<int>(0xc0000123),static_cast<int>(0x5),EACCES,"An I/O request other than close was performed on a file after it has been deleted, which can only happen to a request which did not complete before the last handle was closed via NtClose."},
{ static_cast<int>(0xc0000124),static_cast<int>(0x55b),0,"Indicates an operation has been attempted on a built-in (special) SAM account which is incompatible with built-in accounts. For example, built-in accounts cannot be deleted."},
{ static_cast<int>(0xc0000125),static_cast<int>(0x55c),0,"The operation requested may not be performed on the specified group because it is a built-in special group."},
{ static_cast<int>(0xc0000126),static_cast<int>(0x55d),0,"The operation requested may not be performed on the specified user because it is a built-in special user."},
{ static_cast<int>(0xc0000127),static_cast<int>(0x55e),0,"Indicates a member cannot be removed from a group because the group is currently the member's primary group."},
{ static_cast<int>(0xc0000128),static_cast<int>(0x6),EINVAL,"An I/O request other than close and several other special case operations was attempted using a file object that had already been closed."},
{ static_cast<int>(0xc0000129),static_cast<int>(0x235),0,"Indicates a process has too many threads to perform the requested action. For example, assignment of a primary token may only be performed when a process has zero or one threads."},
{ static_cast<int>(0xc000012a),static_cast<int>(0x236),0,"An attempt was made to operate on a thread within a specific process, but the thread specified is not in the process specified."},
{ static_cast<int>(0xc000012b),static_cast<int>(0x55f),0,"An attempt was made to establish a token for use as a primary token but the token is already in use. A token can only be the primary token of one process at a time."},
{ static_cast<int>(0xc000012c),static_cast<int>(0x237),0,"Page file quota was exceeded."},
{ static_cast<int>(0xc000012d),static_cast<int>(0x5af),0,"{Out of Virtual Memory}\nYour system is low on virtual memory. To ensure that Windows runs properly, increase the size of your virtual memory paging file. For more information, see Help."},
{ static_cast<int>(0xc000012e),static_cast<int>(0xc1),0,"The specified image file did not have the correct format, it appears to be LE format."},
{ static_cast<int>(0xc000012f),static_cast<int>(0xc1),0,"The specified image file did not have the correct format, it did not have an initial MZ."},
{ static_cast<int>(0xc0000130),static_cast<int>(0xc1),0,"The specified image file did not have the correct format, it did not have a proper e_lfarlc in the MZ header."},
{ static_cast<int>(0xc0000131),static_cast<int>(0xc1),0,"The specified image file did not have the correct format, it appears to be a 16-bit Windows image."},
{ static_cast<int>(0xc0000132),static_cast<int>(0x238),0,"The Netlogon service cannot start because another Netlogon service running in the domain conflicts with the specified role."},
{ static_cast<int>(0xc0000133),static_cast<int>(0x576),0,"The time at the Primary Domain Controller is different than the time at the Backup Domain Controller or member server by too large an amount."},
{ static_cast<int>(0xc0000134),static_cast<int>(0x239),0,"The SAM database on a Windows Server is significantly out of synchronization with the copy on the Domain Controller. A complete synchronization is required."},
{ static_cast<int>(0xc0000135),static_cast<int>(0x7e),0,"The code execution cannot proceed because %hs was not found. Reinstalling the program may fix this problem."},
{ static_cast<int>(0xc0000136),static_cast<int>(0x23a),0,"The NtCreateFile API failed. This error should never be returned to an application, it is a place holder for the Windows Lan Manager Redirector to use in its internal error mapping routines."},
{ static_cast<int>(0xc0000137),static_cast<int>(0x23b),0,"{Privilege Failed}\nThe I/O permissions for the process could not be changed."},
{ static_cast<int>(0xc0000138),static_cast<int>(0xb6),0,"{Ordinal Not Found}\nThe ordinal %ld could not be located in the dynamic link library %hs."},
{ static_cast<int>(0xc0000139),static_cast<int>(0x7f),0,"{Entry Point Not Found}\nThe procedure entry point %hs could not be located in the dynamic link library %hs."},
{ static_cast<int>(0xc000013a),static_cast<int>(0x23c),0,"{Application Exit by CTRL+C}\nThe application terminated as a result of a CTRL+C."},
{ static_cast<int>(0xc000013b),static_cast<int>(0x40),0,"{Virtual Circuit Closed}\nThe network transport on your computer has closed a network connection. There may or may not be I/O requests outstanding."},
{ static_cast<int>(0xc000013c),static_cast<int>(0x40),0,"{Virtual Circuit Closed}\nThe network transport on a remote computer has closed a network connection. There may or may not be I/O requests outstanding."},
{ static_cast<int>(0xc000013d),static_cast<int>(0x33),0,"{Insufficient Resources on Remote Computer}\nThe remote computer has insufficient resources to complete the network request. For instance, there may not be enough memory available on the remote computer to carry out the request at this time."},
{ static_cast<int>(0xc000013e),static_cast<int>(0x3b),0,"{Virtual Circuit Closed}\nAn existing connection (virtual circuit) has been broken at the remote computer. There is probably something wrong with the network software protocol or the network hardware on the remote computer."},
{ static_cast<int>(0xc000013f),static_cast<int>(0x3b),0,"{Virtual Circuit Closed}\nThe network transport on your computer has closed a network connection because it had to wait too long for a response from the remote computer."},
{ static_cast<int>(0xc0000140),static_cast<int>(0x3b),0,"The connection handle given to the transport was invalid."},
{ static_cast<int>(0xc0000141),static_cast<int>(0x3b),0,"The address handle given to the transport was invalid."},
{ static_cast<int>(0xc0000142),static_cast<int>(0x45a),0,"{DLL Initialization Failed}\nInitialization of the dynamic link library %hs failed. The process is terminating abnormally."},
{ static_cast<int>(0xc0000143),static_cast<int>(0x23d),0,"{Missing System File}\nThe required system file %hs is bad or missing."},
{ static_cast<int>(0xc0000144),static_cast<int>(0x23e),0,"{Application Error}\nThe exception %s (0x"},
{ static_cast<int>(0xc0000145),static_cast<int>(0x23f),0,"{Application Error}\nThe application was unable to start correctly (0x%lx). Click OK to close the application."},
{ static_cast<int>(0xc0000146),static_cast<int>(0x240),0,"{Unable to Create Paging File}\nThe creation of the paging file %hs failed (%lx). The requested size was %ld."},
{ static_cast<int>(0xc0000147),static_cast<int>(0x242),0,"{No Paging File Specified}\nNo paging file was specified in the system configuration."},
{ static_cast<int>(0xc0000148),static_cast<int>(0x7c),0,"{Incorrect System Call Level}\nAn invalid level was passed into the specified system call."},
{ static_cast<int>(0xc0000149),static_cast<int>(0x56),0,"{Incorrect Password to LAN Manager Server}\nYou specified an incorrect password to a LAN Manager 2.x or MS-NET server."},
{ static_cast<int>(0xc000014a),static_cast<int>(0x243),0,"{EXCEPTION}\nA real-mode application issued a floating-point instruction and floating-point hardware is not present."},
{ static_cast<int>(0xc000014b),static_cast<int>(0x6d),0,"The pipe operation has failed because the other end of the pipe has been closed."},
{ static_cast<int>(0xc000014c),static_cast<int>(0x3f1),0,"{The Registry Is Corrupt}\nThe structure of one of the files that contains Registry data is corrupt, or the image of the file in memory is corrupt, or the file could not be recovered because the alternate copy or log was absent or corrupt."},
{ static_cast<int>(0xc000014d),static_cast<int>(0x3f8),0,"An I/O operation initiated by the Registry failed unrecoverably. The Registry could not read in, or write out, or flush, one of the files that contain the system's image of the Registry."},
{ static_cast<int>(0xc000014e),static_cast<int>(0x244),0,"An event pair synchronization operation was performed using the thread specific client/server event pair object, but no event pair object was associated with the thread."},
{ static_cast<int>(0xc000014f),static_cast<int>(0x3ed),0,"The volume does not contain a recognized file system. Please make sure that all required file system drivers are loaded and that the volume is not corrupt."},
{ static_cast<int>(0xc0000150),static_cast<int>(0x45e),0,"No serial device was successfully initialized. The serial driver will unload."},
{ static_cast<int>(0xc0000151),static_cast<int>(0x560),0,"The specified local group does not exist."},
{ static_cast<int>(0xc0000152),static_cast<int>(0x561),0,"The specified account name is not a member of the group."},
{ static_cast<int>(0xc0000153),static_cast<int>(0x562),0,"The specified account name is already a member of the group."},
{ static_cast<int>(0xc0000154),static_cast<int>(0x563),0,"The specified local group already exists."},
{ static_cast<int>(0xc0000155),static_cast<int>(0x564),0,"A requested type of logon (e.g., Interactive, Network, Service) is not granted by the target system's local security policy.\nPlease ask the system administrator to grant the necessary form of logon."},
{ static_cast<int>(0xc0000156),static_cast<int>(0x565),0,"The maximum number of secrets that may be stored in a single system has been exceeded. The length and number of secrets is limited to satisfy United States State Department export restrictions."},
{ static_cast<int>(0xc0000157),static_cast<int>(0x566),0,"The length of a secret exceeds the maximum length allowed. The length and number of secrets is limited to satisfy United States State Department export restrictions."},
{ static_cast<int>(0xc0000158),static_cast<int>(0x567),0,"The Local Security Authority (LSA) database contains an internal inconsistency."},
{ static_cast<int>(0xc0000159),static_cast<int>(0x3ef),0,"The requested operation cannot be performed in fullscreen mode."},
{ static_cast<int>(0xc000015a),static_cast<int>(0x568),0,"During a logon attempt, the user's security context accumulated too many security IDs. This is a very unusual situation. Remove the user from some global or local groups to reduce the number of security ids to incorporate into the security context."},
{ static_cast<int>(0xc000015b),static_cast<int>(0x569),0,"A user has requested a type of logon (e.g., interactive or network) that has not been granted. An administrator has control over who may logon interactively and through the network."},
{ static_cast<int>(0xc000015c),static_cast<int>(0x3f9),0,"The system has attempted to load or restore a file into the registry, and the specified file is not in the format of a registry file."},
{ static_cast<int>(0xc000015d),static_cast<int>(0x56a),0,"An attempt was made to change a user password in the security account manager without providing the necessary Windows cross-encrypted password."},
{ static_cast<int>(0xc000015e),static_cast<int>(0x245),0,"A Windows Server has an incorrect configuration."},
{ static_cast<int>(0xc000015f),static_cast<int>(0x45d),0,"An attempt was made to explicitly access the secondary copy of information via a device control to the Fault Tolerance driver and the secondary copy is not present in the system."},
{ static_cast<int>(0xc0000160),static_cast<int>(0x4db),0,"A configuration registry node representing a driver service entry was ill-formed and did not contain required value entries."},
{ static_cast<int>(0xc0000161),static_cast<int>(0x246),0,"An illegal character was encountered. For a multi-byte character set this includes a lead byte without a succeeding trail byte. For the Unicode character set this includes the characters 0xFFFF and 0xFFFE."},
{ static_cast<int>(0xc0000162),static_cast<int>(0x459),0,"No mapping for the Unicode character exists in the target multi-byte code page."},
{ static_cast<int>(0xc0000163),static_cast<int>(0x247),0,"The Unicode character is not defined in the Unicode character set installed on the system."},
{ static_cast<int>(0xc0000164),static_cast<int>(0x248),0,"The paging file cannot be created on a floppy diskette."},
{ static_cast<int>(0xc0000165),static_cast<int>(0x462),0,"{Floppy Disk Error}\nWhile accessing a floppy disk, an ID address mark was not found."},
{ static_cast<int>(0xc0000166),static_cast<int>(0x463),0,"{Floppy Disk Error}\nWhile accessing a floppy disk, the track address from the sector ID field was found to be different than the track address maintained by the controller."},
{ static_cast<int>(0xc0000167),static_cast<int>(0x464),0,"{Floppy Disk Error}\nThe floppy disk controller reported an error that is not recognized by the floppy disk driver."},
{ static_cast<int>(0xc0000168),static_cast<int>(0x465),0,"{Floppy Disk Error}\nWhile accessing a floppy-disk, the controller returned inconsistent results via its registers."},
{ static_cast<int>(0xc0000169),static_cast<int>(0x466),0,"{Hard Disk Error}\nWhile accessing the hard disk, a recalibrate operation failed, even after retries."},
{ static_cast<int>(0xc000016a),static_cast<int>(0x467),0,"{Hard Disk Error}\nWhile accessing the hard disk, a disk operation failed even after retries."},
{ static_cast<int>(0xc000016b),static_cast<int>(0x468),0,"{Hard Disk Error}\nWhile accessing the hard disk, a disk controller reset was needed, but even that failed."},
{ static_cast<int>(0xc000016c),static_cast<int>(0x45f),0,"An attempt was made to open a device that was sharing an IRQ with other devices.\nAt least one other device that uses that IRQ was already opened.\nTwo concurrent opens of devices that share an IRQ and only work via interrupts is not supported for the particular bus type that the devices use."},
{ static_cast<int>(0xc000016d),static_cast<int>(0x45d),0,"{FT Orphaning}\nA disk that is part of a fault-tolerant volume can no longer be accessed."},
{ static_cast<int>(0xc000016e),static_cast<int>(0x249),0,"The system bios failed to connect a system interrupt to the device or bus for which the device is connected."},
{ static_cast<int>(0xc0000172),static_cast<int>(0x451),0,"Tape could not be partitioned."},
{ static_cast<int>(0xc0000173),static_cast<int>(0x452),0,"When accessing a new tape of a multivolume partition, the current blocksize is incorrect."},
{ static_cast<int>(0xc0000174),static_cast<int>(0x453),0,"Tape partition information could not be found when loading a tape."},
{ static_cast<int>(0xc0000175),static_cast<int>(0x454),0,"Attempt to lock the eject media mechanism fails."},
{ static_cast<int>(0xc0000176),static_cast<int>(0x455),0,"Unload media fails."},
{ static_cast<int>(0xc0000177),static_cast<int>(0x469),0,"Physical end of tape was detected."},
{ static_cast<int>(0xc0000178),static_cast<int>(0x458),0,"{No Media}\nThere is no media in the drive. Please insert media into drive %hs."},
{ static_cast<int>(0xc000017a),static_cast<int>(0x56b),0,"A member could not be added to or removed from the local group because the member does not exist."},
{ static_cast<int>(0xc000017b),static_cast<int>(0x56c),0,"A new member could not be added to a local group because the member has the wrong account type."},
{ static_cast<int>(0xc000017c),static_cast<int>(0x3fa),0,"Illegal operation attempted on a registry key which has been marked for deletion."},
{ static_cast<int>(0xc000017d),static_cast<int>(0x3fb),0,"System could not allocate required space in a registry log."},
{ static_cast<int>(0xc000017e),static_cast<int>(0x56d),0,"Too many Sids have been specified."},
{ static_cast<int>(0xc000017f),static_cast<int>(0x56e),0,"An attempt was made to change a user password in the security account manager without providing the necessary LM cross-encrypted password."},
{ static_cast<int>(0xc0000180),static_cast<int>(0x3fc),0,"An attempt was made to create a symbolic link in a registry key that already has subkeys or values."},
{ static_cast<int>(0xc0000181),static_cast<int>(0x3fd),0,"An attempt was made to create a Stable subkey under a Volatile parent key."},
{ static_cast<int>(0xc0000182),static_cast<int>(0x57),0,"The I/O device is configured incorrectly or the configuration parameters to the driver are incorrect."},
{ static_cast<int>(0xc0000183),static_cast<int>(0x45d),0,"An error was detected between two drivers or within an I/O driver."},
{ static_cast<int>(0xc0000184),static_cast<int>(0x16),0,"The device is not in a valid state to perform this request."},
{ static_cast<int>(0xc0000185),static_cast<int>(0x45d),0,"The I/O device reported an I/O error."},
{ static_cast<int>(0xc0000186),static_cast<int>(0x45d),0,"A protocol error was detected between the driver and the device."},
{ static_cast<int>(0xc0000187),static_cast<int>(0x24a),0,"This operation is only allowed for the Primary Domain Controller of the domain."},
{ static_cast<int>(0xc0000188),static_cast<int>(0x5de),0,"Log file space is insufficient to support this operation."},
{ static_cast<int>(0xc0000189),static_cast<int>(0x13),EACCES,"A write operation was attempted to a volume after it was dismounted."},
{ static_cast<int>(0xc000018a),static_cast<int>(0x6fa),0,"The workstation does not have a trust secret for the primary domain in the local LSA database."},
{ static_cast<int>(0xc000018b),static_cast<int>(0x6fb),0,"The SAM database on the Windows Server does not have a computer account for this workstation trust relationship."},
{ static_cast<int>(0xc000018c),static_cast<int>(0x6fc),0,"The logon request failed because the trust relationship between the primary domain and the trusted domain failed."},
{ static_cast<int>(0xc000018d),static_cast<int>(0x6fd),0,"The logon request failed because the trust relationship between this workstation and the primary domain failed."},
{ static_cast<int>(0xc000018e),static_cast<int>(0x5dc),0,"The Eventlog log file is corrupt."},
{ static_cast<int>(0xc000018f),static_cast<int>(0x5dd),0,"No Eventlog log file could be opened. The Eventlog service did not start."},
{ static_cast<int>(0xc0000190),static_cast<int>(0x6fe),0,"The network logon failed. This may be because the validation authority can't be reached."},
{ static_cast<int>(0xc0000191),static_cast<int>(0x24b),0,"An attempt was made to acquire a mutant such that its maximum count would have been exceeded."},
{ static_cast<int>(0xc0000192),static_cast<int>(0x700),0,"An attempt was made to logon, but the netlogon service was not started."},
{ static_cast<int>(0xc0000193),static_cast<int>(0x701),0,"The user's account has expired."},
{ static_cast<int>(0xc0000194),static_cast<int>(0x46b),0,"{EXCEPTION}\nPossible deadlock condition."},
{ static_cast<int>(0xc0000195),static_cast<int>(0x4c3),0,"Multiple connections to a server or shared resource by the same user, using more than one user name, are not allowed. Disconnect all previous connections to the server or shared resource and try again."},
{ static_cast<int>(0xc0000196),static_cast<int>(0x4c4),0,"An attempt was made to establish a session to a network server, but there are already too many sessions established to that server."},
{ static_cast<int>(0xc0000197),static_cast<int>(0x5df),0,"The log file has changed between reads."},
{ static_cast<int>(0xc0000198),static_cast<int>(0x70f),0,"The account used is an Interdomain Trust account. Use your global user account or local user account to access this server."},
{ static_cast<int>(0xc0000199),static_cast<int>(0x710),0,"The account used is a Computer Account. Use your global user account or local user account to access this server."},
{ static_cast<int>(0xc000019a),static_cast<int>(0x711),0,"The account used is an Server Trust account. Use your global user account or local user account to access this server."},
{ static_cast<int>(0xc000019b),static_cast<int>(0x712),0,"The name or SID of the domain specified is inconsistent with the trust information for that domain."},
{ static_cast<int>(0xc000019c),static_cast<int>(0x24c),0,"A volume has been accessed for which a file system driver is required that has not yet been loaded."},
{ static_cast<int>(0xc000019d),static_cast<int>(0x420),0,"Indicates that the specified image is already loaded as a DLL."},
{ static_cast<int>(0xc000019e),static_cast<int>(0x130),0,"Short name settings may not be changed on this volume due to the global registry setting."},
{ static_cast<int>(0xc000019f),static_cast<int>(0x131),0,"Short names are not enabled on this volume."},
{ static_cast<int>(0xc00001a0),static_cast<int>(0x132),0,"The security stream for the given volume is in an inconsistent state.\nPlease run CHKDSK on the volume."},
{ static_cast<int>(0xc00001a1),static_cast<int>(0x133),0,"A requested file lock operation cannot be processed due to an invalid byte range."},
{ static_cast<int>(0xc00001a2),static_cast<int>(0x325),0,"{Invalid ACE Condition}\nThe specified access control entry (ACE) contains an invalid condition."},
{ static_cast<int>(0xc00001a3),static_cast<int>(0x134),0,"The subsystem needed to support the image type is not present."},
{ static_cast<int>(0xc00001a4),static_cast<int>(0x135),0,"{Invalid ACE Condition}\nThe specified file already has a notification GUID associated with it."},
{ static_cast<int>(0xc00001a5),static_cast<int>(0x136),0,"An invalid exception handler routine has been detected."},
{ static_cast<int>(0xc00001a6),static_cast<int>(0x137),0,"Duplicate privileges were specified for the token."},
{ static_cast<int>(0xc00001a7),static_cast<int>(0x139),0,"Requested action not allowed on a file system internal file."},
{ static_cast<int>(0xc00001a8),static_cast<int>(0x1abb),0,"A portion of the file system requires repair."},
{ static_cast<int>(0xc00001a9),static_cast<int>(0x32),0,"Quota support is not enabled on the system."},
{ static_cast<int>(0xc00001aa),static_cast<int>(0x3d54),0,"The operation failed because the application is not part of an application package."},
{ static_cast<int>(0xc00001ab),static_cast<int>(0x329),0,"File metadata optimization is already in progress."},
{ static_cast<int>(0xc00001ac),static_cast<int>(0x678),0,"The objects are not identical."},
{ static_cast<int>(0xc00001ad),static_cast<int>(0x8),ENOMEM,"The process has terminated because it could not allocate additional memory."},
{ static_cast<int>(0xc00001ae),static_cast<int>(0x2f7),0,"The process is not part of a job."},
{ static_cast<int>(0xc00001af),static_cast<int>(0x32d),0,"The specified CPU Set IDs are invalid."},
{ static_cast<int>(0xc0000201),static_cast<int>(0x41),0,"A remote open failed because the network open restrictions were not satisfied."},
{ static_cast<int>(0xc0000202),static_cast<int>(0x572),0,"There is no user session key for the specified logon session."},
{ static_cast<int>(0xc0000203),static_cast<int>(0x3b),0,"The remote user session has been deleted."},
{ static_cast<int>(0xc0000204),static_cast<int>(0x717),0,"Indicates the specified resource language ID cannot be found in the\nimage file."},
{ static_cast<int>(0xc0000205),static_cast<int>(0x46a),0,"Insufficient server resources exist to complete the request."},
{ static_cast<int>(0xc0000206),static_cast<int>(0x6f8),0,"The size of the buffer is invalid for the specified operation."},
{ static_cast<int>(0xc0000207),static_cast<int>(0x4be),0,"The transport rejected the network address specified as invalid."},
{ static_cast<int>(0xc0000208),static_cast<int>(0x4be),0,"The transport rejected the network address specified due to an invalid use of a wildcard."},
{ static_cast<int>(0xc0000209),static_cast<int>(0x44),0,"The transport address could not be opened because all the available addresses are in use."},
{ static_cast<int>(0xc000020a),static_cast<int>(0x34),0,"The transport address could not be opened because it already exists."},
{ static_cast<int>(0xc000020b),static_cast<int>(0x40),0,"The transport address is now closed."},
{ static_cast<int>(0xc000020c),static_cast<int>(0x40),0,"The transport connection is now disconnected."},
{ static_cast<int>(0xc000020d),static_cast<int>(0x40),0,"The transport connection has been reset."},
{ static_cast<int>(0xc000020e),static_cast<int>(0x44),0,"The transport cannot dynamically acquire any more nodes."},
{ static_cast<int>(0xc000020f),static_cast<int>(0x3b),0,"The transport aborted a pending transaction."},
{ static_cast<int>(0xc0000210),static_cast<int>(0x3b),0,"The transport timed out a request waiting for a response."},
{ static_cast<int>(0xc0000211),static_cast<int>(0x3b),0,"The transport did not receive a release for a pending response."},
{ static_cast<int>(0xc0000212),static_cast<int>(0x3b),0,"The transport did not find a transaction matching the specific token."},
{ static_cast<int>(0xc0000213),static_cast<int>(0x3b),0,"The transport had previously responded to a transaction request."},
{ static_cast<int>(0xc0000214),static_cast<int>(0x3b),0,"The transport does not recognized the transaction request identifier specified."},
{ static_cast<int>(0xc0000215),static_cast<int>(0x3b),0,"The transport does not recognize the transaction request type specified."},
{ static_cast<int>(0xc0000216),static_cast<int>(0x32),0,"The transport can only process the specified request on the server side of a session."},
{ static_cast<int>(0xc0000217),static_cast<int>(0x32),0,"The transport can only process the specified request on the client side of a session."},
{ static_cast<int>(0xc0000218),static_cast<int>(0x24d),0,"{Registry File Failure}\nThe registry cannot load the hive (file):\n%hs\nor its log or alternate.\nIt is corrupt, absent, or not writable."},
{ static_cast<int>(0xc0000219),static_cast<int>(0x24e),0,"{Unexpected Failure in DebugActiveProcess}\nAn unexpected failure occurred while processing a DebugActiveProcess API request. You may choose OK to terminate the process, or Cancel to ignore the error."},
{ static_cast<int>(0xc000021a),static_cast<int>(0x24f),0,"{Fatal System Error}\nThe %hs system process terminated unexpectedly with a status of 0x"},
{ static_cast<int>(0xc000021b),static_cast<int>(0x250),0,"{Data Not Accepted}\nThe TDI client could not handle the data received during an indication."},
{ static_cast<int>(0xc000021c),static_cast<int>(0x17e6),0,"{Unable to Retrieve Browser Server List}\nThe list of servers for this workgroup is not currently available."},
{ static_cast<int>(0xc000021d),static_cast<int>(0x251),0,"NTVDM encountered a hard error."},
{ static_cast<int>(0xc000021e),static_cast<int>(0x252),0,"{Cancel Timeout}\nThe driver %hs failed to complete a cancelled I/O request in the allotted time."},
{ static_cast<int>(0xc000021f),static_cast<int>(0x253),0,"{Reply Message Mismatch}\nAn attempt was made to reply to an LPC message, but the thread specified by the client ID in the message was not waiting on that message."},
{ static_cast<int>(0xc0000220),static_cast<int>(0x46c),0,"{Mapped View Alignment Incorrect}\nAn attempt was made to map a view of a file, but either the specified base address or the offset into the file were not aligned on the proper allocation granularity."},
{ static_cast<int>(0xc0000221),static_cast<int>(0xc1),0,"{Bad Image Checksum}\nThe image %hs is possibly corrupt. The header checksum does not match the computed checksum."},
{ static_cast<int>(0xc0000222),static_cast<int>(0x254),0,"{Delayed Write Failed}\nWindows was unable to save all the data for the file %hs. The data has been lost. This error may be caused by a failure of your computer hardware or network connection. Please try to save this file elsewhere."},
{ static_cast<int>(0xc0000223),static_cast<int>(0x255),0,"The parameter(s) passed to the server in the client/server shared memory window were invalid. Too much data may have been put in the shared memory window."},
{ static_cast<int>(0xc0000224),static_cast<int>(0x773),0,"The user's password must be changed before signing in."},
{ static_cast<int>(0xc0000225),static_cast<int>(0x490),0,"The object was not found."},
{ static_cast<int>(0xc0000226),static_cast<int>(0x256),0,"The stream is not a tiny stream."},
{ static_cast<int>(0xc0000227),static_cast<int>(0x4ff),0,"A transaction recover failed."},
{ static_cast<int>(0xc0000228),static_cast<int>(0x257),0,"The request must be handled by the stack overflow code."},
{ static_cast<int>(0xc0000229),static_cast<int>(0x57),0,"A consistency check failed."},
{ static_cast<int>(0xc000022a),static_cast<int>(0x1392),0,"The attempt to insert the ID in the index failed because the ID is already in the index."},
{ static_cast<int>(0xc000022b),static_cast<int>(0x1392),0,"The attempt to set the object's ID failed because the object already has an ID."},
{ static_cast<int>(0xc000022c),static_cast<int>(0x258),0,"Internal OFS status codes indicating how an allocation operation is handled. Either it is retried after the containing onode is moved or the extent stream is converted to a large stream."},
{ static_cast<int>(0xc000022d),static_cast<int>(0x4d5),EAGAIN,"The request needs to be retried."},
{ static_cast<int>(0xc000022e),static_cast<int>(0x259),0,"The attempt to find the object found an object matching by ID on the volume but it is out of the scope of the handle used for the operation."},
{ static_cast<int>(0xc000022f),static_cast<int>(0x25a),0,"The bucket array must be grown. Retry transaction after doing so."},
{ static_cast<int>(0xc0000230),static_cast<int>(0x492),0,"The property set specified does not exist on the object."},
{ static_cast<int>(0xc0000231),static_cast<int>(0x25b),0,"The user/kernel marshalling buffer has overflowed."},
{ static_cast<int>(0xc0000232),static_cast<int>(0x25c),0,"The supplied variant structure contains invalid data."},
{ static_cast<int>(0xc0000233),static_cast<int>(0x774),0,"Could not find a domain controller for this domain."},
{ static_cast<int>(0xc0000234),static_cast<int>(0x775),0,"The user account has been automatically locked because too many invalid logon attempts or password change attempts have been requested."},
{ static_cast<int>(0xc0000235),static_cast<int>(0x6),EINVAL,"NtClose was called on a handle that was protected from close via NtSetInformationObject."},
{ static_cast<int>(0xc0000236),static_cast<int>(0x4c9),0,"The transport connection attempt was refused by the remote system."},
{ static_cast<int>(0xc0000237),static_cast<int>(0x4ca),0,"The transport connection was gracefully closed."},
{ static_cast<int>(0xc0000238),static_cast<int>(0x4cb),0,"The transport endpoint already has an address associated with it."},
{ static_cast<int>(0xc0000239),static_cast<int>(0x4cc),0,"An address has not yet been associated with the transport endpoint."},
{ static_cast<int>(0xc000023a),static_cast<int>(0x4cd),0,"An operation was attempted on a nonexistent transport connection."},
{ static_cast<int>(0xc000023b),static_cast<int>(0x4ce),0,"An invalid operation was attempted on an active transport connection."},
{ static_cast<int>(0xc000023c),static_cast<int>(0x4cf),0,"The remote network is not reachable by the transport."},
{ static_cast<int>(0xc000023d),static_cast<int>(0x4d0),0,"The remote system is not reachable by the transport."},
{ static_cast<int>(0xc000023e),static_cast<int>(0x4d1),0,"The remote system does not support the transport protocol."},
{ static_cast<int>(0xc000023f),static_cast<int>(0x4d2),0,"No service is operating at the destination port of the transport on the remote system."},
{ static_cast<int>(0xc0000240),static_cast<int>(0x4d3),0,"The request was aborted."},
{ static_cast<int>(0xc0000241),static_cast<int>(0x4d4),0,"The transport connection was aborted by the local system."},
{ static_cast<int>(0xc0000242),static_cast<int>(0x25d),0,"The specified buffer contains ill-formed data."},
{ static_cast<int>(0xc0000243),static_cast<int>(0x4c8),0,"The requested operation cannot be performed on a file with a user mapped section open."},
{ static_cast<int>(0xc0000244),static_cast<int>(0x25e),0,"{Audit Failed}\nAn attempt to generate a security audit failed."},
{ static_cast<int>(0xc0000245),static_cast<int>(0x25f),0,"The timer resolution was not previously set by the current process."},
{ static_cast<int>(0xc0000246),static_cast<int>(0x4d6),0,"A connection to the server could not be made because the limit on the number of concurrent connections for this account has been reached."},
{ static_cast<int>(0xc0000247),static_cast<int>(0x4d7),0,"Attempting to login during an unauthorized time of day for this account."},
{ static_cast<int>(0xc0000248),static_cast<int>(0x4d8),0,"The account is not authorized to login from this station."},
{ static_cast<int>(0xc0000249),static_cast<int>(0xc1),0,"{UP/MP Image Mismatch}\nThe image %hs has been modified for use on a uniprocessor system, but you are running it on a multiprocessor machine.\nPlease reinstall the image file."},
{ static_cast<int>(0xc0000250),static_cast<int>(0x260),0,"There is insufficient account information to log you on."},
{ static_cast<int>(0xc0000251),static_cast<int>(0x261),0,"{Invalid DLL Entrypoint}\nThe dynamic link library %hs is not written correctly. The stack pointer has been left in an inconsistent state. The entrypoint should be declared as WINAPI or STDCALL. Select YES to fail the DLL load. Select NO to continue execution. Selecting NO may cause the application to operate incorrectly."},
{ static_cast<int>(0xc0000252),static_cast<int>(0x262),0,"{Invalid Service Callback Entrypoint}\nThe %hs service is not written correctly. The stack pointer has been left in an inconsistent state. The callback entrypoint should be declared as WINAPI or STDCALL. Selecting OK will cause the service to continue operation. However, the service process may operate incorrectly."},
{ static_cast<int>(0xc0000253),static_cast<int>(0x4d4),0,"The server received the messages but did not send a reply."},
{ static_cast<int>(0xc0000254),static_cast<int>(0x263),0,"There is an IP address conflict with another system on the network"},
{ static_cast<int>(0xc0000255),static_cast<int>(0x264),0,"There is an IP address conflict with another system on the network"},
{ static_cast<int>(0xc0000256),static_cast<int>(0x265),0,"{Low On Registry Space}\nThe system has reached the maximum size allowed for the system part of the registry. Additional storage requests will be ignored."},
{ static_cast<int>(0xc0000257),static_cast<int>(0x4d0),0,"The contacted server does not support the indicated part of the DFS namespace."},
{ static_cast<int>(0xc0000258),static_cast<int>(0x266),0,"A callback return system service cannot be executed when no callback is active."},
{ static_cast<int>(0xc0000259),static_cast<int>(0x573),0,"The service being accessed is licensed for a particular number of connections. No more connections can be made to the service at this time because there are already as many connections as the service can accept."},
{ static_cast<int>(0xc000025a),static_cast<int>(0x267),0,"The password provided is too short to meet the policy of your user account. Please choose a longer password."},
{ static_cast<int>(0xc000025b),static_cast<int>(0x268),0,"The policy of your user account does not allow you to change passwords too frequently. This is done to prevent users from changing back to a familiar, but potentially discovered, password. If you feel your password has been compromised then please contact your administrator immediately to have a new one assigned."},
{ static_cast<int>(0xc000025c),static_cast<int>(0x269),0,"You have attempted to change your password to one that you have used in the past. The policy of your user account does not allow this. Please select a password that you have not previously used."},
{ static_cast<int>(0xc000025e),static_cast<int>(0x422),0,"You have attempted to load a legacy device driver while its device instance had been disabled."},
{ static_cast<int>(0xc000025f),static_cast<int>(0x26a),0,"The specified compression format is unsupported."},
{ static_cast<int>(0xc0000260),static_cast<int>(0x26b),0,"The specified hardware profile configuration is invalid."},
{ static_cast<int>(0xc0000261),static_cast<int>(0x26c),0,"The specified Plug and Play registry device path is invalid."},
{ static_cast<int>(0xc0000262),static_cast<int>(0xb6),0,"{Driver Entry Point Not Found}\nThe %hs device driver could not locate the ordinal %ld in driver %hs."},
{ static_cast<int>(0xc0000263),static_cast<int>(0x7f),0,"{Driver Entry Point Not Found}\nThe %hs device driver could not locate the entry point %hs in driver %hs."},
{ static_cast<int>(0xc0000264),static_cast<int>(0x120),0,"{Application Error}\nThe application attempted to release a resource it did not own. Click OK to terminate the application."},
{ static_cast<int>(0xc0000265),static_cast<int>(0x476),0,"An attempt was made to create more links on a file than the file system supports."},
{ static_cast<int>(0xc0000266),static_cast<int>(0x26d),0,"The specified quota list is internally inconsistent with its descriptor."},
{ static_cast<int>(0xc0000267),static_cast<int>(0x10fe),0,"The specified file has been relocated to offline storage."},
{ static_cast<int>(0xc0000268),static_cast<int>(0x26e),0,"{Windows Evaluation Notification}\nThe evaluation period for this installation of Windows has expired. This system will shutdown in 1 hour. To restore access to this installation of Windows, please upgrade this installation using a licensed distribution of this product."},
{ static_cast<int>(0xc0000269),static_cast<int>(0x26f),0,"{Illegal System DLL Relocation}\nThe system DLL %hs was relocated in memory. The application will not run properly. The relocation occurred because the DLL %hs occupied an address range reserved for Windows system DLLs. The vendor supplying the DLL should be contacted for a new DLL."},
{ static_cast<int>(0xc000026a),static_cast<int>(0x1b8e),0,"{License Violation}\nThe system has detected tampering with your registered product type. This is a violation of your software license. Tampering with product type is not permitted."},
{ static_cast<int>(0xc000026b),static_cast<int>(0x270),0,"{DLL Initialization Failed}\nThe application failed to initialize because the window station is shutting down."},
{ static_cast<int>(0xc000026c),static_cast<int>(0x7d1),0,"{Unable to Load Device Driver}\n%hs device driver could not be loaded.\nError Status was 0x%x"},
{ static_cast<int>(0xc000026d),static_cast<int>(0x4b1),0,"DFS is unavailable on the contacted server."},
{ static_cast<int>(0xc000026e),static_cast<int>(0x15),EAGAIN,"An operation was attempted to a volume after it was dismounted."},
{ static_cast<int>(0xc000026f),static_cast<int>(0x21c),0,"An internal error occurred in the Win32 x86 emulation subsystem."},
{ static_cast<int>(0xc0000270),static_cast<int>(0x21c),0,"Win32 x86 emulation subsystem Floating-point stack check."},
{ static_cast<int>(0xc0000271),static_cast<int>(0x271),0,"The validation process needs to continue on to the next step."},
{ static_cast<int>(0xc0000272),static_cast<int>(0x491),0,"There was no match for the specified key in the index."},
{ static_cast<int>(0xc0000273),static_cast<int>(0x272),0,"There are no more matches for the current index enumeration."},
{ static_cast<int>(0xc0000275),static_cast<int>(0x1126),0,"The NTFS file or directory is not a reparse point."},
{ static_cast<int>(0xc0000276),static_cast<int>(0x1129),0,"The Windows I/O reparse tag passed for the NTFS reparse point is invalid."},
{ static_cast<int>(0xc0000277),static_cast<int>(0x112a),0,"The Windows I/O reparse tag does not match the one present in the NTFS reparse point."},
{ static_cast<int>(0xc0000278),static_cast<int>(0x1128),0,"The user data passed for the NTFS reparse point is invalid."},
{ static_cast<int>(0xc0000279),static_cast<int>(0x780),0,"The layered file system driver for this IO tag did not handle it when needed."},
{ static_cast<int>(0xc000027a),static_cast<int>(0x291),0,"The password provided is too long to meet the policy of your user account. Please choose a shorter password."},
{ static_cast<int>(0xc000027b),static_cast<int>(0x54f),0,"An application-internal exception has occurred."},
{ static_cast<int>(0xc0000280),static_cast<int>(0x781),0,"The NTFS symbolic link could not be resolved even though the initial file name is valid."},
{ static_cast<int>(0xc0000281),static_cast<int>(0xa1),0,"The NTFS directory is a reparse point."},
{ static_cast<int>(0xc0000282),static_cast<int>(0x273),0,"The range could not be added to the range list because of a conflict."},
{ static_cast<int>(0xc0000283),static_cast<int>(0x488),0,"The specified medium changer source element contains no media."},
{ static_cast<int>(0xc0000284),static_cast<int>(0x489),0,"The specified medium changer destination element already contains media."},
{ static_cast<int>(0xc0000285),static_cast<int>(0x48a),0,"The specified medium changer element does not exist."},
{ static_cast<int>(0xc0000286),static_cast<int>(0x48b),0,"The specified element is contained within a magazine that is no longer present."},
{ static_cast<int>(0xc0000287),static_cast<int>(0x48c),0,"The device requires reinitialization due to hardware errors."},
{ static_cast<int>(0xc000028a),static_cast<int>(0x5),EACCES,"The file encryption attempt failed."},
{ static_cast<int>(0xc000028b),static_cast<int>(0x5),EACCES,"The file decryption attempt failed."},
{ static_cast<int>(0xc000028c),static_cast<int>(0x284),0,"The specified range could not be found in the range list."},
{ static_cast<int>(0xc000028d),static_cast<int>(0x5),EACCES,"There is no encryption recovery policy configured for this system."},
{ static_cast<int>(0xc000028e),static_cast<int>(0x5),EACCES,"The required encryption driver is not loaded for this system."},
{ static_cast<int>(0xc000028f),static_cast<int>(0x5),EACCES,"The file was encrypted with a different encryption driver than is currently loaded."},
{ static_cast<int>(0xc0000290),static_cast<int>(0x5),EACCES,"There are no EFS keys defined for the user."},
{ static_cast<int>(0xc0000291),static_cast<int>(0x1777),0,"The specified file is not encrypted."},
{ static_cast<int>(0xc0000292),static_cast<int>(0x1778),0,"The specified file is not in the defined EFS export format."},
{ static_cast<int>(0xc0000293),static_cast<int>(0x1772),0,"The specified file is encrypted and the user does not have the ability to decrypt it."},
{ static_cast<int>(0xc0000295),static_cast<int>(0x1068),0,"The guid passed was not recognized as valid by a WMI data provider."},
{ static_cast<int>(0xc0000296),static_cast<int>(0x1069),0,"The instance name passed was not recognized as valid by a WMI data provider."},
{ static_cast<int>(0xc0000297),static_cast<int>(0x106a),0,"The data item id passed was not recognized as valid by a WMI data provider."},
{ static_cast<int>(0xc0000298),static_cast<int>(0x106b),0,"The WMI request could not be completed and should be retried."},
{ static_cast<int>(0xc0000299),static_cast<int>(0x201a),0,"The policy object is shared and can only be modified at the root"},
{ static_cast<int>(0xc000029a),static_cast<int>(0x201b),0,"The policy object does not exist when it should"},
{ static_cast<int>(0xc000029b),static_cast<int>(0x201c),0,"The requested policy information only lives in the Ds"},
{ static_cast<int>(0xc000029c),static_cast<int>(0x1),ENOSYS,"The volume must be upgraded to enable this feature"},
{ static_cast<int>(0xc000029d),static_cast<int>(0x10ff),0,"The remote storage service is not operational at this time."},
{ static_cast<int>(0xc000029e),static_cast<int>(0x1100),0,"The remote storage service encountered a media error."},
{ static_cast<int>(0xc000029f),static_cast<int>(0x494),0,"The tracking (workstation) service is not running."},
{ static_cast<int>(0xc00002a0),static_cast<int>(0x274),0,"The server process is running under a SID different than that required by client."},
{ static_cast<int>(0xc00002a1),static_cast<int>(0x200a),0,"The specified directory service attribute or value does not exist."},
{ static_cast<int>(0xc00002a2),static_cast<int>(0x200b),0,"The attribute syntax specified to the directory service is invalid."},
{ static_cast<int>(0xc00002a3),static_cast<int>(0x200c),0,"The attribute type specified to the directory service is not defined."},
{ static_cast<int>(0xc00002a4),static_cast<int>(0x200d),0,"The specified directory service attribute or value already exists."},
{ static_cast<int>(0xc00002a5),static_cast<int>(0x200e),0,"The directory service is busy."},
{ static_cast<int>(0xc00002a6),static_cast<int>(0x200f),0,"The directory service is not available."},
{ static_cast<int>(0xc00002a7),static_cast<int>(0x2010),0,"The directory service was unable to allocate a relative identifier."},
{ static_cast<int>(0xc00002a8),static_cast<int>(0x2011),0,"The directory service has exhausted the pool of relative identifiers."},
{ static_cast<int>(0xc00002a9),static_cast<int>(0x2012),0,"The requested operation could not be performed because the directory service is not the master for that type of operation."},
{ static_cast<int>(0xc00002aa),static_cast<int>(0x2013),0,"The directory service was unable to initialize the subsystem that allocates relative identifiers."},
{ static_cast<int>(0xc00002ab),static_cast<int>(0x2014),0,"The requested operation did not satisfy one or more constraints associated with the class of the object."},
{ static_cast<int>(0xc00002ac),static_cast<int>(0x2015),0,"The directory service can perform the requested operation only on a leaf object."},
{ static_cast<int>(0xc00002ad),static_cast<int>(0x2016),0,"The directory service cannot perform the requested operation on the Relatively Defined Name (RDN) attribute of an object."},
{ static_cast<int>(0xc00002ae),static_cast<int>(0x2017),0,"The directory service detected an attempt to modify the object class of an object."},
{ static_cast<int>(0xc00002af),static_cast<int>(0x2018),0,"An error occurred while performing a cross domain move operation."},
{ static_cast<int>(0xc00002b0),static_cast<int>(0x2019),0,"Unable to Contact the Global Catalog Server."},
{ static_cast<int>(0xc00002b1),static_cast<int>(0x211e),0,"The requested operation requires a directory service, and none was available."},
{ static_cast<int>(0xc00002b2),static_cast<int>(0x1127),0,"The reparse attribute cannot be set as it is incompatible with an existing attribute."},
{ static_cast<int>(0xc00002b3),static_cast<int>(0x275),0,"A group marked use for deny only cannot be enabled."},
{ static_cast<int>(0xc00002b4),static_cast<int>(0x276),0,"{EXCEPTION}\nMultiple floating point faults."},
{ static_cast<int>(0xc00002b5),static_cast<int>(0x277),0,"{EXCEPTION}\nMultiple floating point traps."},
{ static_cast<int>(0xc00002b6),static_cast<int>(0x651),0,"The device has been removed."},
{ static_cast<int>(0xc00002b7),static_cast<int>(0x49a),0,"The volume change journal is being deleted."},
{ static_cast<int>(0xc00002b8),static_cast<int>(0x49b),0,"The volume change journal is not active."},
{ static_cast<int>(0xc00002b9),static_cast<int>(0x278),0,"The requested interface is not supported."},
{ static_cast<int>(0xc00002ba),static_cast<int>(0x2047),0,"The directory service detected the subsystem that allocates relative identifiers is disabled. This can occur as a protective mechanism when the system determines a significant portion of relative identifiers (RIDs) have been exhausted. Please see http://go.microsoft.com/fwlink/?LinkId=228610 for recommended diagnostic steps and the procedure to re-enable account creation."},
{ static_cast<int>(0xc00002c1),static_cast<int>(0x2024),0,"A directory service resource limit has been exceeded."},
{ static_cast<int>(0xc00002c2),static_cast<int>(0x279),0,"{System Standby Failed}\nThe driver %hs does not support standby mode. Updating this driver may allow the system to go to standby mode."},
{ static_cast<int>(0xc00002c3),static_cast<int>(0x575),0,"Mutual Authentication failed. The server's password is out of date at the domain controller."},
{ static_cast<int>(0xc00002c4),static_cast<int>(0x27a),0,"The system file %1 has become corrupt and has been replaced."},
{ static_cast<int>(0xc00002c5),static_cast<int>(0x3e6),EACCES,"{EXCEPTION}\nAlignment Error\nA datatype misalignment error was detected in a load or store instruction."},
{ static_cast<int>(0xc00002c6),static_cast<int>(0x1075),0,"The WMI data item or data block is read only."},
{ static_cast<int>(0xc00002c7),static_cast<int>(0x1076),0,"The WMI data item or data block could not be changed."},
{ static_cast<int>(0xc00002c8),static_cast<int>(0x27b),0,"{Virtual Memory Minimum Too Low}\nYour system is low on virtual memory. Windows is increasing the size of your virtual memory paging file. During this process, memory requests for some applications may be denied. For more information, see Help."},
{ static_cast<int>(0xc00002c9),static_cast<int>(0x4ed),0,"{EXCEPTION}\nRegister NaT consumption faults.\nA NaT value is consumed on a non speculative instruction."},
{ static_cast<int>(0xc00002ca),static_cast<int>(0x10e8),0,"The medium changer's transport element contains media, which is causing the operation to fail."},
{ static_cast<int>(0xc00002cb),static_cast<int>(0x2138),0,"Security Accounts Manager initialization failed because of the following error:\n%hs\nError Status: 0x%x.\nPlease shutdown this system and reboot into Directory Services Restore Mode, check the event log for more detailed information."},
{ static_cast<int>(0xc00002cc),static_cast<int>(0x4e3),0,"This operation is supported only when you are connected to the server."},
{ static_cast<int>(0xc00002cd),static_cast<int>(0x2139),0,"Only an administrator can modify the membership list of an administrative group."},
{ static_cast<int>(0xc00002ce),static_cast<int>(0x27c),0,"A device was removed so enumeration must be restarted."},
{ static_cast<int>(0xc00002cf),static_cast<int>(0x49d),0,"The journal entry has been deleted from the journal."},
{ static_cast<int>(0xc00002d0),static_cast<int>(0x213a),0,"Cannot change the primary group ID of a domain controller account."},
{ static_cast<int>(0xc00002d1),static_cast<int>(0x27d),0,"{Fatal System Error}\nThe system image %s is not properly signed. The file has been replaced with the signed file. The system has been shut down."},
{ static_cast<int>(0xc00002d2),static_cast<int>(0x27e),0,"Device will not start without a reboot."},
{ static_cast<int>(0xc00002d3),static_cast<int>(0x15),EAGAIN,"Current device power state cannot support this request."},
{ static_cast<int>(0xc00002d4),static_cast<int>(0x2141),0,"The specified group type is invalid."},
{ static_cast<int>(0xc00002d5),static_cast<int>(0x2142),0,"In mixed domain no nesting of global group if group is security enabled."},
{ static_cast<int>(0xc00002d6),static_cast<int>(0x2143),0,"In mixed domain, cannot nest local groups with other local groups, if the group is security enabled."},
{ static_cast<int>(0xc00002d7),static_cast<int>(0x2144),0,"A global group cannot have a local group as a member."},
{ static_cast<int>(0xc00002d8),static_cast<int>(0x2145),0,"A global group cannot have a universal group as a member."},
{ static_cast<int>(0xc00002d9),static_cast<int>(0x2146),0,"A universal group cannot have a local group as a member."},
{ static_cast<int>(0xc00002da),static_cast<int>(0x2147),0,"A global group cannot have a cross domain member."},
{ static_cast<int>(0xc00002db),static_cast<int>(0x2148),0,"A local group cannot have another cross domain local group as a member."},
{ static_cast<int>(0xc00002dc),static_cast<int>(0x2149),0,"Cannot change to security disabled group because of having primary members in this group."},
{ static_cast<int>(0xc00002dd),static_cast<int>(0x32),0,"The WMI operation is not supported by the data block or method."},
{ static_cast<int>(0xc00002de),static_cast<int>(0x27f),0,"There is not enough power to complete the requested operation."},
{ static_cast<int>(0xc00002df),static_cast<int>(0x2151),0,"Security Account Manager needs to get the boot password."},
{ static_cast<int>(0xc00002e0),static_cast<int>(0x2152),0,"Security Account Manager needs to get the boot key from floppy disk."},
{ static_cast<int>(0xc00002e1),static_cast<int>(0x2153),0,"Directory Service cannot start."},
{ static_cast<int>(0xc00002e2),static_cast<int>(0x2154),0,"Directory Services could not start because of the following error:\n%hs\nError Status: 0x%x.\nPlease shutdown this system and reboot into Directory Services Restore Mode, check the event log for more detailed information."},
{ static_cast<int>(0xc00002e3),static_cast<int>(0x215d),0,"Security Accounts Manager initialization failed because of the following error:\n%hs\nError Status: 0x%x.\nPlease click OK to shutdown this system and reboot into Safe Mode, check the event log for more detailed information."},
{ static_cast<int>(0xc00002e4),static_cast<int>(0x2163),0,"The requested operation can be performed only on a global catalog server."},
{ static_cast<int>(0xc00002e5),static_cast<int>(0x2164),0,"A local group can only be a member of other local groups in the same domain."},
{ static_cast<int>(0xc00002e6),static_cast<int>(0x2165),0,"Foreign security principals cannot be members of universal groups."},
{ static_cast<int>(0xc00002e7),static_cast<int>(0x216d),0,"Your computer could not be joined to the domain. You have exceeded the maximum number of computer accounts you are allowed to create in this domain. Contact your system administrator to have this limit reset or increased."},
{ static_cast<int>(0xc00002e8),static_cast<int>(0x280),0,"STATUS_MULTIPLE_FAULT_VIOLATION"},
{ static_cast<int>(0xc00002e9),static_cast<int>(0x577),0,"This operation cannot be performed on the current domain."},
{ static_cast<int>(0xc00002ea),static_cast<int>(0x52),EACCES,"The directory or file cannot be created."},
{ static_cast<int>(0xc00002eb),static_cast<int>(0x281),0,"The system is in the process of shutting down."},
{ static_cast<int>(0xc00002ec),static_cast<int>(0x2171),0,"Directory Services could not start because of the following error:\n%hs\nError Status: 0x%x.\nPlease click OK to shutdown the system. You can use the recovery console to diagnose the system further."},
{ static_cast<int>(0xc00002ed),static_cast<int>(0x2172),0,"Security Accounts Manager initialization failed because of the following error:\n%hs\nError Status: 0x%x.\nPlease click OK to shutdown the system. You can use the recovery console to diagnose the system further."},
{ static_cast<int>(0xc00002ee),static_cast<int>(0x80090333),0,"A security context was deleted before the context was completed. This is considered a logon failure."},
{ static_cast<int>(0xc00002ef),static_cast<int>(0x80090334),0,"The client is trying to negotiate a context and the server requires user-to-user but didn't send a TGT reply."},
{ static_cast<int>(0xc00002f0),static_cast<int>(0x2),ENOENT,"An object ID was not found in the file."},
{ static_cast<int>(0xc00002f1),static_cast<int>(0x80090335),0,"Unable to accomplish the requested task because the local machine does not have any IP addresses."},
{ static_cast<int>(0xc00002f2),static_cast<int>(0x80090336),0,"The supplied credential handle does not match the credential associated with the security context."},
{ static_cast<int>(0xc00002f3),static_cast<int>(0x80090337),0,"The crypto system or checksum function is invalid because a required function is unavailable."},
{ static_cast<int>(0xc00002f4),static_cast<int>(0x80090338),0,"The number of maximum ticket referrals has been exceeded."},
{ static_cast<int>(0xc00002f5),static_cast<int>(0x80090339),0,"The local machine must be a Kerberos KDC (domain controller) and it is not."},
{ static_cast<int>(0xc00002f6),static_cast<int>(0x8009033a),0,"The other end of the security negotiation is requires strong crypto but it is not supported on the local machine."},
{ static_cast<int>(0xc00002f7),static_cast<int>(0x8009033b),0,"The KDC reply contained more than one principal name."},
{ static_cast<int>(0xc00002f8),static_cast<int>(0x8009033c),0,"Expected to find PA data for a hint of what etype to use, but it was not found."},
{ static_cast<int>(0xc00002f9),static_cast<int>(0x8009033d),0,"The client certificate does not contain a valid UPN, or does not match the client name in the logon request. Please contact your administrator."},
{ static_cast<int>(0xc00002fa),static_cast<int>(0x8009033e),0,"Smartcard logon is required and was not used."},
{ static_cast<int>(0xc00002fb),static_cast<int>(0x80090340),0,"An invalid request was sent to the KDC."},
{ static_cast<int>(0xc00002fc),static_cast<int>(0x80090341),0,"The KDC was unable to generate a referral for the service requested."},
{ static_cast<int>(0xc00002fd),static_cast<int>(0x80090342),0,"The encryption type requested is not supported by the KDC."},
{ static_cast<int>(0xc00002fe),static_cast<int>(0x45b),0,"A system shutdown is in progress."},
{ static_cast<int>(0xc00002ff),static_cast<int>(0x4e7),0,"The server machine is shutting down."},
{ static_cast<int>(0xc0000300),static_cast<int>(0x4e6),0,"This operation is not supported on a computer running Windows Server 2003 for Small Business Server"},
{ static_cast<int>(0xc0000301),static_cast<int>(0x106f),0,"The WMI GUID is no longer available"},
{ static_cast<int>(0xc0000302),static_cast<int>(0x1074),0,"Collection or events for the WMI GUID is already disabled."},
{ static_cast<int>(0xc0000303),static_cast<int>(0x106e),0,"Collection or events for the WMI GUID is already enabled."},
{ static_cast<int>(0xc0000304),static_cast<int>(0x12e),0,"The Master File Table on the volume is too fragmented to complete this operation."},
{ static_cast<int>(0xc0000305),static_cast<int>(0x80030305),0,"Copy protection failure."},
{ static_cast<int>(0xc0000306),static_cast<int>(0x80030306),0,"Copy protection error - DVD CSS Authentication failed."},
{ static_cast<int>(0xc0000307),static_cast<int>(0x80030307),0,"Copy protection error - The given sector does not contain a valid key."},
{ static_cast<int>(0xc0000308),static_cast<int>(0x80030308),0,"Copy protection error - DVD session key not established."},
{ static_cast<int>(0xc0000309),static_cast<int>(0x80030309),0,"Copy protection error - The read failed because the sector is encrypted."},
{ static_cast<int>(0xc000030a),static_cast<int>(0x8003030a),0,"Copy protection error - The given DVD's region does not correspond to the\nregion setting of the drive."},
{ static_cast<int>(0xc000030b),static_cast<int>(0x8003030b),0,"Copy protection error - The drive's region setting may be permanent."},
{ static_cast<int>(0xc000030c),static_cast<int>(0x792),0,"EAS policy requires that the user change their password before this operation can be performed."},
{ static_cast<int>(0xc000030d),static_cast<int>(0x793),0,"An administrator has restricted sign in. To sign in, make sure your device is connected to the Internet, and have your administrator sign in first."},
{ static_cast<int>(0xc0000320),static_cast<int>(0x4ef),0,"The Kerberos protocol encountered an error while validating the KDC certificate during logon. There is more information in the system event log."},
{ static_cast<int>(0xc0000321),static_cast<int>(0x4f0),0,"The Kerberos protocol encountered an error while attempting to utilize the smartcard subsystem."},
{ static_cast<int>(0xc0000322),static_cast<int>(0x80090348),0,"The target server does not have acceptable Kerberos credentials."},
{ static_cast<int>(0xc0000350),static_cast<int>(0x4e8),0,"The transport determined that the remote system is down."},
{ static_cast<int>(0xc0000351),static_cast<int>(0x80090343),0,"An unsupported preauthentication mechanism was presented to the Kerberos package."},
{ static_cast<int>(0xc0000352),static_cast<int>(0x177d),0,"The encryption algorithm used on the source file needs a bigger key buffer than the one used on the destination file."},
{ static_cast<int>(0xc0000353),static_cast<int>(0x282),0,"An attempt to remove a process's DebugPort was made, but a port was not already associated with the process."},
{ static_cast<int>(0xc0000354),static_cast<int>(0x504),0,"Debugger Inactive: Windows may have been started without kernel debugging enabled."},
{ static_cast<int>(0xc0000355),static_cast<int>(0x283),0,"This version of Windows is not compatible with the behavior version of directory forest, domain or domain controller."},
{ static_cast<int>(0xc0000356),static_cast<int>(0xc0090001),0,"The specified event is currently not being audited."},
{ static_cast<int>(0xc0000357),static_cast<int>(0x217c),0,"The machine account was created pre-NT4. The account needs to be recreated."},
{ static_cast<int>(0xc0000358),static_cast<int>(0x2182),0,"A account group cannot have a universal group as a member."},
{ static_cast<int>(0xc0000359),static_cast<int>(0xc1),0,"The specified image file did not have the correct format, it appears to be a 32-bit Windows image."},
{ static_cast<int>(0xc000035a),static_cast<int>(0xc1),0,"The specified image file did not have the correct format, it appears to be a 64-bit Windows image."},
{ static_cast<int>(0xc000035b),static_cast<int>(0x80090346),0,"Client's supplied SSPI channel bindings were incorrect."},
{ static_cast<int>(0xc000035c),static_cast<int>(0x572),0,"The client's session has expired, so the client must reauthenticate to continue accessing the remote resources."},
{ static_cast<int>(0xc000035d),static_cast<int>(0x4eb),0,"AppHelp dialog canceled thus preventing the application from starting."},
{ static_cast<int>(0xc000035e),static_cast<int>(0xc0090002),0,"The SID filtering operation removed all SIDs."},
{ static_cast<int>(0xc000035f),static_cast<int>(0x286),0,"The driver was not loaded because the system is booting into safe mode."},
{ static_cast<int>(0xc0000361),static_cast<int>(0x4ec),0,"Access to %1 has been restricted by your Administrator by the default software restriction policy level."},
{ static_cast<int>(0xc0000362),static_cast<int>(0x4ec),0,"Access to %1 has been restricted by your Administrator by location with policy rule %2 placed on path %3"},
{ static_cast<int>(0xc0000363),static_cast<int>(0x4ec),0,"Access to %1 has been restricted by your Administrator by software publisher policy."},
{ static_cast<int>(0xc0000364),static_cast<int>(0x4ec),0,"Access to %1 has been restricted by your Administrator by policy rule %2."},
{ static_cast<int>(0xc0000365),static_cast<int>(0x287),0,"The driver was not loaded because it failed its initialization call."},
{ static_cast<int>(0xc0000366),static_cast<int>(0x288),0,"The \"%hs\" encountered an error while applying power or reading the device configuration. This may be caused by a failure of your hardware or by a poor connection."},
{ static_cast<int>(0xc0000368),static_cast<int>(0x289),0,"The create operation failed because the name contained at least one mount point which resolves to a volume to which the specified device object is not attached."},
{ static_cast<int>(0xc0000369),static_cast<int>(0x28a),0,"The device object parameter is either not a valid device object or is not attached to the volume specified by the file name."},
{ static_cast<int>(0xc000036a),static_cast<int>(0x28b),0,"A Machine Check Error has occurred. Please check the system eventlog for additional information."},
{ static_cast<int>(0xc000036b),static_cast<int>(0x4fb),0,"Driver %2 has been blocked from loading."},
{ static_cast<int>(0xc000036c),static_cast<int>(0x4fb),0,"Driver %2 has been blocked from loading."},
{ static_cast<int>(0xc000036d),static_cast<int>(0x28c),0,"There was error [%2] processing the driver database."},
{ static_cast<int>(0xc000036e),static_cast<int>(0x28d),0,"System hive size has exceeded its limit."},
{ static_cast<int>(0xc000036f),static_cast<int>(0x4fc),0,"A dynamic link library (DLL) referenced a module that was neither a DLL nor the process's executable image."},
{ static_cast<int>(0xc0000371),static_cast<int>(0x21ac),0,"The local account store does not contain secret material for the specified account."},
{ static_cast<int>(0xc0000372),static_cast<int>(0x312),0,"Access to %1 has been restricted by your Administrator by policy rule %2."},
{ static_cast<int>(0xc0000373),static_cast<int>(0x8),ENOMEM,"The system was not able to allocate enough memory to perform a stack switch."},
{ static_cast<int>(0xc0000374),static_cast<int>(0x54f),0,"A heap has been corrupted."},
{ static_cast<int>(0xc0000380),static_cast<int>(0x8010006b),0,"An incorrect PIN was presented to the smart card"},
{ static_cast<int>(0xc0000381),static_cast<int>(0x8010006c),0,"The smart card is blocked"},
{ static_cast<int>(0xc0000382),static_cast<int>(0x8010006f),0,"No PIN was presented to the smart card"},
{ static_cast<int>(0xc0000383),static_cast<int>(0x8010000c),0,"No smart card available"},
{ static_cast<int>(0xc0000384),static_cast<int>(0x8009000d),0,"The requested key container does not exist on the smart card"},
{ static_cast<int>(0xc0000385),static_cast<int>(0x8010002c),0,"The requested certificate does not exist on the smart card"},
{ static_cast<int>(0xc0000386),static_cast<int>(0x80090016),0,"The requested keyset does not exist"},
{ static_cast<int>(0xc0000387),static_cast<int>(0x8010002f),0,"A communication error with the smart card has been detected."},
{ static_cast<int>(0xc0000388),static_cast<int>(0x4f1),0,"The system cannot contact a domain controller to service the authentication request. Please try again later."},
{ static_cast<int>(0xc0000389),static_cast<int>(0x80090351),0,"The smartcard certificate used for authentication has been revoked. Please contact your system administrator. There may be additional information in the event log."},
{ static_cast<int>(0xc000038a),static_cast<int>(0x80090352),0,"An untrusted certificate authority was detected while processing the certificate used for authentication."},
{ static_cast<int>(0xc000038b),static_cast<int>(0x80090353),0,"The revocation status of the certificate used for authentication could not be determined."},
{ static_cast<int>(0xc000038c),static_cast<int>(0x80090354),0,"The client certificate used for authentication was not trusted."},
{ static_cast<int>(0xc000038d),static_cast<int>(0x80090355),0,"The smartcard certificate used for authentication has expired. Please\ncontact your system administrator."},
{ static_cast<int>(0xc000038e),static_cast<int>(0x28e),0,"The driver could not be loaded because a previous version of the driver is still in memory."},
{ static_cast<int>(0xc000038f),static_cast<int>(0x80090022),0,"The smartcard provider could not perform the action since the context was acquired as silent."},
{ static_cast<int>(0xc0000401),static_cast<int>(0x78c),0,"The current user's delegated trust creation quota has been exceeded."},
{ static_cast<int>(0xc0000402),static_cast<int>(0x78d),0,"The total delegated trust creation quota has been exceeded."},
{ static_cast<int>(0xc0000403),static_cast<int>(0x78e),0,"The current user's delegated trust deletion quota has been exceeded."},
{ static_cast<int>(0xc0000404),static_cast<int>(0x217b),0,"The requested name already exists as a unique identifier."},
{ static_cast<int>(0xc0000405),static_cast<int>(0x219d),0,"The requested object has a non-unique identifier and cannot be retrieved."},
{ static_cast<int>(0xc0000406),static_cast<int>(0x219f),0,"The group cannot be converted due to attribute restrictions on the requested group type."},
{ static_cast<int>(0xc0000407),static_cast<int>(0x28f),0,"{Volume Shadow Copy Service}\nPlease wait while the Volume Shadow Copy Service prepares volume %hs for hibernation."},
{ static_cast<int>(0xc0000408),static_cast<int>(0x52e),0,"Kerberos sub-protocol User2User is required."},
{ static_cast<int>(0xc0000409),static_cast<int>(0x502),0,"The system detected an overrun of a stack-based buffer in this application. This overrun could potentially allow a malicious user to gain control of this application."},
{ static_cast<int>(0xc000040a),static_cast<int>(0x80090356),0,"The Kerberos subsystem encountered an error. A service for user protocol request was made against a domain controller which does not support service for user."},
{ static_cast<int>(0xc000040b),static_cast<int>(0x80090357),0,"An attempt was made by this server to make a Kerberos constrained delegation request for a target outside of the server's realm. This is not supported, and indicates a misconfiguration on this server's allowed to delegate to list. Please contact your administrator."},
{ static_cast<int>(0xc000040c),static_cast<int>(0x80090358),0,"The revocation status of the domain controller certificate used for authentication could not be determined. There is additional information in the system event log."},
{ static_cast<int>(0xc000040d),static_cast<int>(0x80090359),0,"An untrusted certificate authority was detected while processing the domain controller certificate used for authentication. There is additional information in the system event log. Please contact your system administrator."},
{ static_cast<int>(0xc000040e),static_cast<int>(0x8009035a),0,"The domain controller certificate used for logon has expired. There is additional information in the system event log."},
{ static_cast<int>(0xc000040f),static_cast<int>(0x8009035b),0,"The domain controller certificate used for logon has been revoked. There is additional information in the system event log."},
{ static_cast<int>(0xc0000410),static_cast<int>(0x503),0,"Data present in one of the parameters is more than the function can operate on."},
{ static_cast<int>(0xc0000411),static_cast<int>(0x290),0,"The system has failed to hibernate (The error code is %hs). Hibernation will be disabled until the system is restarted."},
{ static_cast<int>(0xc0000412),static_cast<int>(0x505),0,"An attempt to delay-load a .dll or get a function address in a delay-loaded .dll failed."},
{ static_cast<int>(0xc0000413),static_cast<int>(0x78f),0,"Logon Failure: The machine you are logging onto is protected by an authentication firewall. The specified account is not allowed to authenticate to the machine."},
{ static_cast<int>(0xc0000414),static_cast<int>(0x506),0,"%hs is a 16-bit application. You do not have permissions to execute 16-bit applications. Check your permissions with your system administrator."},
{ static_cast<int>(0xc0000415),static_cast<int>(0x80260001),0,"{Display Driver Stopped Responding}\nThe %hs display driver has stopped working normally. Save your work and reboot the system to restore full display functionality. The next time you reboot the machine a dialog will be displayed giving you a chance to report this failure to Microsoft."},
{ static_cast<int>(0xc0000416),static_cast<int>(0x8),ENOMEM,"The Desktop heap encountered an error while allocating session memory. There is more information in the system event log."},
{ static_cast<int>(0xc0000417),static_cast<int>(0x508),0,"An invalid parameter was passed to a C runtime function."},
{ static_cast<int>(0xc0000418),static_cast<int>(0x791),0,"The authentication failed since NTLM was blocked."},
{ static_cast<int>(0xc0000419),static_cast<int>(0x215b),0,"The source object's SID already exists in destination forest."},
{ static_cast<int>(0xc000041a),static_cast<int>(0x21ba),0,"The domain name of the trusted domain already exists in the forest."},
{ static_cast<int>(0xc000041b),static_cast<int>(0x21bb),0,"The flat name of the trusted domain already exists in the forest."},
{ static_cast<int>(0xc000041c),static_cast<int>(0x21bc),0,"The User Principal Name (UPN) is invalid."},
{ static_cast<int>(0xc000041d),static_cast<int>(0x2c9),0,"An unhandled exception was encountered during a user callback."},
{ static_cast<int>(0xc0000420),static_cast<int>(0x29c),0,"An assertion failure has occurred."},
{ static_cast<int>(0xc0000421),static_cast<int>(0x219),0,"Application verifier has found an error in the current process."},
{ static_cast<int>(0xc0000423),static_cast<int>(0x300),0,"An exception has occurred in a user mode callback and the kernel callback frame should be removed."},
{ static_cast<int>(0xc0000424),static_cast<int>(0x4fb),0,"%2 has been blocked from loading due to incompatibility with this system. Please contact your software vendor for a compatible version of the driver."},
{ static_cast<int>(0xc0000425),static_cast<int>(0x3fa),0,"Illegal operation attempted on a registry key which has already been unloaded."},
{ static_cast<int>(0xc0000426),static_cast<int>(0x301),0,"Compression is disabled for this volume."},
{ static_cast<int>(0xc0000427),static_cast<int>(0x299),0,"The requested operation could not be completed due to a file system limitation"},
{ static_cast<int>(0xc0000428),static_cast<int>(0x241),0,"Windows cannot verify the digital signature for this file. A recent hardware or software change might have installed a file that is signed incorrectly or damaged, or that might be malicious software from an unknown source."},
{ static_cast<int>(0xc0000429),static_cast<int>(0x307),0,"The implementation is not capable of performing the request."},
{ static_cast<int>(0xc000042a),static_cast<int>(0x308),0,"The requested operation is out of order with respect to other operations."},
{ static_cast<int>(0xc000042b),static_cast<int>(0x50c),0,"An operation attempted to exceed an implementation-defined limit."},
{ static_cast<int>(0xc000042c),static_cast<int>(0x2e4),0,"The requested operation requires elevation."},
{ static_cast<int>(0xc000042d),static_cast<int>(0x80090361),0,"The required security context does not exist."},
{ static_cast<int>(0xc000042f),static_cast<int>(0x80090362),0,"The PKU2U protocol encountered an error while attempting to utilize the associated certificates."},
{ static_cast<int>(0xc0000432),static_cast<int>(0x509),0,"The operation was attempted beyond the valid data length of the file."},
{ static_cast<int>(0xc0000433),static_cast<int>(0xaa),EBUSY,"The attempted write operation encountered a write already in progress for some portion of the range."},
{ static_cast<int>(0xc0000434),static_cast<int>(0xaa),EBUSY,"The page fault mappings changed in the middle of processing a fault so the operation must be retried."},
{ static_cast<int>(0xc0000435),static_cast<int>(0x4c8),0,"The attempt to purge this file from memory failed to purge some or all the data from memory."},
{ static_cast<int>(0xc0000440),static_cast<int>(0x80097019),0,"The requested credential requires confirmation."},
{ static_cast<int>(0xc0000441),static_cast<int>(0x1781),0,"The remote server sent an invalid response for a file being opened with Client Side Encryption."},
{ static_cast<int>(0xc0000442),static_cast<int>(0x1782),0,"Client Side Encryption is not supported by the remote server even though it claims to support it."},
{ static_cast<int>(0xc0000443),static_cast<int>(0x1783),0,"File is encrypted and should be opened in Client Side Encryption mode."},
{ static_cast<int>(0xc0000444),static_cast<int>(0x1784),0,"A new encrypted file is being created and a $EFS needs to be provided."},
{ static_cast<int>(0xc0000445),static_cast<int>(0x1785),0,"The SMB client requested a CSE FSCTL on a non-CSE file."},
{ static_cast<int>(0xc0000446),static_cast<int>(0x513),0,"Indicates a particular Security ID may not be assigned as the label of an object."},
{ static_cast<int>(0xc0000450),static_cast<int>(0x50b),0,"The process hosting the driver for this device has terminated."},
{ static_cast<int>(0xc0000451),static_cast<int>(0x3b92),0,"The requested system device cannot be identified due to multiple indistinguishable devices potentially matching the identification criteria."},
{ static_cast<int>(0xc0000452),static_cast<int>(0x3bc3),0,"The requested system device cannot be found."},
{ static_cast<int>(0xc0000453),static_cast<int>(0x5bb),0,"This boot application must be restarted."},
{ static_cast<int>(0xc0000454),static_cast<int>(0x5be),0,"Insufficient NVRAM resources exist to complete the API.  A reboot might be required."},
{ static_cast<int>(0xc0000455),static_cast<int>(0x6),EINVAL,"The specified session is invalid."},
{ static_cast<int>(0xc0000456),static_cast<int>(0x57),0,"The specified thread is already in a session."},
{ static_cast<int>(0xc0000457),static_cast<int>(0x57),0,"The specified thread is not in a session."},
{ static_cast<int>(0xc0000458),static_cast<int>(0x57),0,"The specified weight is invalid."},
{ static_cast<int>(0xc0000459),static_cast<int>(0xbea),0,"The operation was paused."},
{ static_cast<int>(0xc0000460),static_cast<int>(0x138),0,"No ranges for the specified operation were able to be processed."},
{ static_cast<int>(0xc0000461),static_cast<int>(0x13a),0,"The physical resources of this disk have been exhausted."},
{ static_cast<int>(0xc0000462),static_cast<int>(0x3cfc),0,"The application cannot be started. Try reinstalling the application to fix the problem."},
{ static_cast<int>(0xc0000463),static_cast<int>(0x13c),0,"{Device Feature Not Supported}\nThe device does not support the command feature."},
{ static_cast<int>(0xc0000464),static_cast<int>(0x141),0,"{Source/Destination device unreachable}\nThe device is unreachable."},
{ static_cast<int>(0xc0000465),static_cast<int>(0x13b),0,"{Invalid Proxy Data Token}\nThe token representing the data is invalid."},
{ static_cast<int>(0xc0000466),static_cast<int>(0x40),0,"The file server is temporarily unavailable."},
{ static_cast<int>(0xc0000467),static_cast<int>(0x20),EACCES,"The file is temporarily unavailable."},
{ static_cast<int>(0xc0000468),static_cast<int>(0x142),0,"{Device Insufficient Resources}\nThe target device has insufficient resources to complete the operation."},
{ static_cast<int>(0xc0000469),static_cast<int>(0x3d00),0,"The application cannot be started because it is currently updating."},
{ static_cast<int>(0xc000046a),static_cast<int>(0x151),0,"The specified copy of the requested data could not be read."},
{ static_cast<int>(0xc000046b),static_cast<int>(0x152),0,"The specified data could not be written to any of the copies."},
{ static_cast<int>(0xc000046c),static_cast<int>(0x153),0,"One or more copies of data on this device may be out of sync. No writes may be performed until a data integrity scan is completed."},
{ static_cast<int>(0xc000046d),static_cast<int>(0x156),0,"This object is not externally backed by any provider."},
{ static_cast<int>(0xc000046e),static_cast<int>(0x157),0,"The external backing provider is not recognized."},
{ static_cast<int>(0xc000046f),static_cast<int>(0x158),0,"Compressing this object would not save space."},
{ static_cast<int>(0xc0000470),static_cast<int>(0x143),0,"A data integrity checksum error occurred. Data in the file stream is corrupt."},
{ static_cast<int>(0xc0000471),static_cast<int>(0x144),0,"An attempt was made to modify both a KERNEL and normal Extended Attribute (EA) in the same operation."},
{ static_cast<int>(0xc0000472),static_cast<int>(0x146),0,"{LogicalBlockProvisioningReadZero Not Supported}\nThe target device does not support read returning zeros from trimmed/unmapped blocks."},
{ static_cast<int>(0xc0000473),static_cast<int>(0x14b),0,"{Maximum Segment Descriptors Exceeded}\nThe command specified a number of descriptors that exceeded the maximum supported by the device."},
{ static_cast<int>(0xc0000474),static_cast<int>(0x147),0,"{Alignment Violation}\nThe command specified a data offset that does not align to the device's granularity/alignment."},
{ static_cast<int>(0xc0000475),static_cast<int>(0x148),0,"{Invalid Field In Parameter List}\nThe command specified an invalid field in its parameter list."},
{ static_cast<int>(0xc0000476),static_cast<int>(0x149),0,"{Operation In Progress}\nAn operation is currently in progress with the device."},
{ static_cast<int>(0xc0000477),static_cast<int>(0x14a),0,"{Invalid I_T Nexus}\nAn attempt was made to send down the command via an invalid path to the target device."},
{ static_cast<int>(0xc0000478),static_cast<int>(0x14c),0,"Scrub is disabled on the specified file."},
{ static_cast<int>(0xc0000479),static_cast<int>(0x14d),0,"The storage device does not provide redundancy."},
{ static_cast<int>(0xc000047a),static_cast<int>(0x14e),0,"An operation is not supported on a resident file."},
{ static_cast<int>(0xc000047b),static_cast<int>(0x14f),0,"An operation is not supported on a compressed file."},
{ static_cast<int>(0xc000047c),static_cast<int>(0x150),0,"An operation is not supported on a directory."},
{ static_cast<int>(0xc000047d),static_cast<int>(0x5b4),0,"{IO Operation Timeout}\nThe specified I/O operation failed to complete within the expected time period."},
{ static_cast<int>(0xc000047e),static_cast<int>(0x3d07),0,"An error in a system binary was detected. Try refreshing the PC to fix the problem."},
{ static_cast<int>(0xc000047f),static_cast<int>(0x3d08),0,"A corrupted CLR NGEN binary was detected on the system."},
{ static_cast<int>(0xc0000480),static_cast<int>(0x40),0,"The share is temporarily unavailable."},
{ static_cast<int>(0xc0000481),static_cast<int>(0x7e),0,"The target dll was not found because the apiset %hs is not hosted."},
{ static_cast<int>(0xc0000482),static_cast<int>(0x7e),0,"The API set extension contains a host for a non-existent API set."},
{ static_cast<int>(0xc0000483),static_cast<int>(0x1e3),0,"The request failed due to a fatal device hardware error."},
{ static_cast<int>(0xc0000484),static_cast<int>(0x80030208),0,"The specified firmware slot is invalid."},
{ static_cast<int>(0xc0000485),static_cast<int>(0x80030209),0,"The specified firmware image is invalid."},
{ static_cast<int>(0xc0000486),static_cast<int>(0x159),0,"The request failed due to a storage topology ID mismatch."},
{ static_cast<int>(0xc0000487),static_cast<int>(0x1f),0,"The specified Windows Image (WIM) is not marked as bootable."},
{ static_cast<int>(0xc0000488),static_cast<int>(0x15a),0,"The operation was blocked by parental controls."},
{ static_cast<int>(0xc0000489),static_cast<int>(0x3d0f),0,"The deployment operation failed because the specified application needs to be registered first."},
{ static_cast<int>(0xc000048a),static_cast<int>(0x32a),0,"The requested operation failed due to quota operation is still in progress."},
{ static_cast<int>(0xc000048b),static_cast<int>(0x32c),0,"The callback function must be invoked inline."},
{ static_cast<int>(0xc000048c),static_cast<int>(0x15b),0,"A file system block being referenced has already reached the maximum reference count and can't be referenced any further."},
{ static_cast<int>(0xc000048d),static_cast<int>(0x15c),0,"The requested operation failed because the file stream is marked to disallow writes."},
{ static_cast<int>(0xc000048e),static_cast<int>(0x162),0,"Windows Information Protection policy does not allow access to this network resource."},
{ static_cast<int>(0xc000048f),static_cast<int>(0x15d),0,"The requested operation failed with an architecture-specific failure code."},
{ static_cast<int>(0xc0000490),static_cast<int>(0x491),0,"There are no compatible drivers available for this device."},
{ static_cast<int>(0xc0000491),static_cast<int>(0x2),ENOENT,"The specified driver package cannot be found on the system."},
{ static_cast<int>(0xc0000492),static_cast<int>(0x490),0,"The driver package cannot find a required driver configuration."},
{ static_cast<int>(0xc0000493),static_cast<int>(0x492),0,"The driver configuration is incomplete for use with this device."},
{ static_cast<int>(0xc0000494),static_cast<int>(0x307),0,"The device requires a driver configuration with a function driver."},
{ static_cast<int>(0xc0000495),static_cast<int>(0x15),EAGAIN,"The device is pending further configuration."},
{ static_cast<int>(0xc0000496),static_cast<int>(0x163),0,"The device hint name buffer is too small to receive the remaining name."},
{ static_cast<int>(0xc0000497),static_cast<int>(0x3d5a),0,"The package is currently not available."},
{ static_cast<int>(0xc0000499),static_cast<int>(0x167),0,"The device is in maintenance mode."},
{ static_cast<int>(0xc000049a),static_cast<int>(0x168),0,"This operation is not supported on a DAX volume."},
{ static_cast<int>(0xc000049b),static_cast<int>(0x12e),0,"The free space on the volume is too fragmented to complete this operation."},
{ static_cast<int>(0xc000049c),static_cast<int>(0x169),0,"The volume has active DAX mappings."},
{ static_cast<int>(0xc000049d),static_cast<int>(0x16f),0,"The process creation has been blocked."},
{ static_cast<int>(0xc000049e),static_cast<int>(0x170),0,"The storage device has lost data or persistence."},
{ static_cast<int>(0xc000049f),static_cast<int>(0x49f),0,"Driver Verifier Volatile settings cannot be set when CFG is enabled."},
{ static_cast<int>(0xc0000500),static_cast<int>(0x60e),0,"The specified task name is invalid."},
{ static_cast<int>(0xc0000501),static_cast<int>(0x60f),0,"The specified task index is invalid."},
{ static_cast<int>(0xc0000502),static_cast<int>(0x610),0,"The specified thread is already joining a task."},
{ static_cast<int>(0xc0000503),static_cast<int>(0x15),EAGAIN,"A callback has requested to bypass native code."},
{ static_cast<int>(0xc0000504),static_cast<int>(0x13f),0,"The Central Access Policy specified is not defined on the target machine."},
{ static_cast<int>(0xc0000505),static_cast<int>(0x140),0,"The Central Access Policy obtained from Active Directory is invalid."},
{ static_cast<int>(0xc0000506),static_cast<int>(0x5bf),0,"Unable to finish the requested operation because the specified process is not a GUI process."},
{ static_cast<int>(0xc0000507),static_cast<int>(0xaa),EBUSY,"The device is not responding and cannot be safely removed."},
{ static_cast<int>(0xc0000508),static_cast<int>(0x5e0),0,"The specified Job already has a container assigned to it."},
{ static_cast<int>(0xc0000509),static_cast<int>(0x5e1),0,"The specified Job does not have a container assigned to it."},
{ static_cast<int>(0xc000050a),static_cast<int>(0x8003020a),0,"The device is unresponsive."},
{ static_cast<int>(0xc000050b),static_cast<int>(0x112b),0,"The object manager encountered a reparse point while retrieving an object."},
{ static_cast<int>(0xc000050c),static_cast<int>(0x8083000a),0,"The requested attribute is not present on the specified file or directory."},
{ static_cast<int>(0xc000050d),static_cast<int>(0x80830009),0,"This volume is not a tiered volume."},
{ static_cast<int>(0xc000050e),static_cast<int>(0x115c),0,"This file is currently associated with a different stream id."},
{ static_cast<int>(0xc000050f),static_cast<int>(0x10d3),0,"The requested operation could not be completed because the specified job has children."},
{ static_cast<int>(0xc0000510),static_cast<int>(0x4df),0,"The specified object has already been initialized."},
{ static_cast<int>(0xc0000602),static_cast<int>(0x675),0,"{Fail Fast Exception}\nA fail fast exception occurred. Exception handlers will not be invoked and the process will be terminated immediately."},
{ static_cast<int>(0xc0000603),static_cast<int>(0x800b010c),0,"Windows cannot verify the digital signature for this file. The signing certificate for this file has been revoked."},
{ static_cast<int>(0xc0000604),static_cast<int>(0x677),0,"The operation was blocked as the process prohibits dynamic code generation."},
{ static_cast<int>(0xc0000605),static_cast<int>(0x800b0101),0,"Windows cannot verify the digital signature for this file. The signing certificate for this file has expired."},
{ static_cast<int>(0xc0000606),static_cast<int>(0x679),0,"The specified image file was blocked from loading because it does not enable a feature required by the process: Control Flow Guard."},
{ static_cast<int>(0xc0000607),static_cast<int>(0x67a),0,"The specified image file was blocked from loading because it does not enable a feature required by the process: Return Flow Guard."},
{ static_cast<int>(0xc0000608),static_cast<int>(0x67b),0,"An invalid memory access occurred to a Return Flow Guard restricted region."},
{ static_cast<int>(0xc0000609),static_cast<int>(0x67b),0,"An invalid memory access occurred to a Return Flow Guard restricted region from an attached process."},
{ static_cast<int>(0xc000060a),static_cast<int>(0x67c),0,"The thread context could not be updated because this has been restricted for the process."},
{ static_cast<int>(0xc000060b),static_cast<int>(0x67d),0,"An attempt to access another partition's private file/section was rejected."},
{ static_cast<int>(0xc000060c),static_cast<int>(0x67b),0,"This process triggered an invalid memory access to a Return Flow Guard restricted region while attached to another process."},
{ static_cast<int>(0xc0000700),static_cast<int>(0x54f),0,"The ALPC port is closed."},
{ static_cast<int>(0xc0000701),static_cast<int>(0x54f),0,"The ALPC message requested is no longer available."},
{ static_cast<int>(0xc0000702),static_cast<int>(0x57),0,"The ALPC message supplied is invalid."},
{ static_cast<int>(0xc0000703),static_cast<int>(0x54f),0,"The ALPC message has been canceled."},
{ static_cast<int>(0xc0000704),static_cast<int>(0x32),0,"Invalid recursive dispatch attempt."},
{ static_cast<int>(0xc0000705),static_cast<int>(0x57),0,"No receive buffer has been supplied in a synchrounus request."},
{ static_cast<int>(0xc0000706),static_cast<int>(0x57),0,"The connection port is used in an invalid context."},
{ static_cast<int>(0xc0000707),static_cast<int>(0x32),0,"The ALPC port does not accept new request messages."},
{ static_cast<int>(0xc0000708),static_cast<int>(0x54f),0,"The resource requested is already in use."},
{ static_cast<int>(0xc0000709),static_cast<int>(0x30b),0,"The hardware has reported an uncorrectable memory error."},
{ static_cast<int>(0xc000070a),static_cast<int>(0x6),EINVAL,"Status 0x"},
{ static_cast<int>(0xc000070b),static_cast<int>(0x6),EINVAL,"After a callback to 0x%p(0x%p), a completion call to SetEvent(0x%p) failed with status 0x"},
{ static_cast<int>(0xc000070c),static_cast<int>(0x6),EINVAL,"After a callback to 0x%p(0x%p), a completion call to ReleaseSemaphore(0x%p, %d) failed with status 0x"},
{ static_cast<int>(0xc000070d),static_cast<int>(0x6),EINVAL,"After a callback to 0x%p(0x%p), a completion call to ReleaseMutex(%p) failed with status 0x"},
{ static_cast<int>(0xc000070e),static_cast<int>(0x6),EINVAL,"After a callback to 0x%p(0x%p), an completion call to FreeLibrary(%p) failed with status 0x"},
{ static_cast<int>(0xc000070f),static_cast<int>(0x6),EINVAL,"The threadpool 0x%p was released while a thread was posting a callback to 0x%p(0x%p) to it."},
{ static_cast<int>(0xc0000710),static_cast<int>(0x1),ENOSYS,"A threadpool worker thread is impersonating a client, after a callback to 0x%p(0x%p).\nThis is unexpected, indicating that the callback is missing a call to revert the impersonation."},
{ static_cast<int>(0xc0000711),static_cast<int>(0x1),ENOSYS,"A threadpool worker thread is impersonating a client, after executing an APC.\nThis is unexpected, indicating that the APC is missing a call to revert the impersonation."},
{ static_cast<int>(0xc0000712),static_cast<int>(0x50d),0,"Either the target process, or the target thread's containing process, is a protected process."},
{ static_cast<int>(0xc0000713),static_cast<int>(0x310),0,"A Thread is getting dispatched with MCA EXCEPTION because of MCA."},
{ static_cast<int>(0xc0000714),static_cast<int>(0x52e),0,"The client certificate account mapping is not unique."},
{ static_cast<int>(0xc0000715),static_cast<int>(0x5b7),0,"The symbolic link cannot be followed because its type is disabled."},
{ static_cast<int>(0xc0000716),static_cast<int>(0x7b),EINVAL,"Indicates that the specified string is not valid for IDN normalization."},
{ static_cast<int>(0xc0000717),static_cast<int>(0x459),0,"No mapping for the Unicode character exists in the target multi-byte code page."},
{ static_cast<int>(0xc0000718),static_cast<int>(0x54f),0,"The provided callback is already registered."},
{ static_cast<int>(0xc0000719),static_cast<int>(0x54f),0,"The provided context did not match the target."},
{ static_cast<int>(0xc000071a),static_cast<int>(0x54f),0,"The specified port already has a completion list."},
{ static_cast<int>(0xc000071b),static_cast<int>(0x1),ENOSYS,"A threadpool worker thread enter a callback at thread base priority 0x%x and exited at priority 0x%x.\nThis is unexpected, indicating that the callback missed restoring the priority."},
{ static_cast<int>(0xc000071c),static_cast<int>(0x57),0,"An invalid thread, handle %p, is specified for this operation. Possibly, a threadpool worker thread was specified."},
{ static_cast<int>(0xc000071d),static_cast<int>(0x1),ENOSYS,"A threadpool worker thread enter a callback, which left transaction state.\nThis is unexpected, indicating that the callback missed clearing the transaction."},
{ static_cast<int>(0xc000071e),static_cast<int>(0x1),ENOSYS,"A threadpool worker thread enter a callback, which left the loader lock held.\nThis is unexpected, indicating that the callback missed releasing the lock."},
{ static_cast<int>(0xc000071f),static_cast<int>(0x1),ENOSYS,"A threadpool worker thread enter a callback, which left with preferred languages set.\nThis is unexpected, indicating that the callback missed clearing them."},
{ static_cast<int>(0xc0000720),static_cast<int>(0x1),ENOSYS,"A threadpool worker thread enter a callback, which left with background priorities set.\nThis is unexpected, indicating that the callback missed restoring the original priorities."},
{ static_cast<int>(0xc0000721),static_cast<int>(0x1),ENOSYS,"A threadpool worker thread enter a callback at thread affinity %p and exited at affinity %p.\nThis is unexpected, indicating that the callback missed restoring the priority."},
{ static_cast<int>(0xc0000722),static_cast<int>(0x72b),0,"The caller has exceeded the maximum number of handles that may be transmitted in\na single local procedure call."},
{ static_cast<int>(0xc0000800),static_cast<int>(0x30c),0,"The attempted operation required self healing to be enabled."},
{ static_cast<int>(0xc0000801),static_cast<int>(0x21a4),0,"The Directory Service cannot perform the requested operation because a domain rename operation is in progress."},
{ static_cast<int>(0xc0000802),static_cast<int>(0x50f),0,"The requested file operation failed because the storage quota was exceeded.\nTo free up disk space, move files to a different location or delete unnecessary files. For more information, contact your system administrator."},
{ static_cast<int>(0xc0000804),static_cast<int>(0x510),0,"The requested file operation failed because the storage policy blocks that type of file. For more information, contact your system administrator."},
{ static_cast<int>(0xc0000805),static_cast<int>(0x1ac1),0,"The operation could not be completed due to bad clusters on disk."},
{ static_cast<int>(0xc0000806),static_cast<int>(0x1ac3),0,"The operation could not be completed because the volume is dirty. Please run chkdsk and try again."},
{ static_cast<int>(0xc0000808),static_cast<int>(0x319),0,"The volume repair was not successful."},
{ static_cast<int>(0xc0000809),static_cast<int>(0x31a),0,"One of the volume corruption logs is full. Further corruptions that may be detected won't be logged."},
{ static_cast<int>(0xc000080a),static_cast<int>(0x31b),0,"One of the volume corruption logs is internally corrupted and needs to be recreated. The volume may contain undetected corruptions and must be scanned."},
{ static_cast<int>(0xc000080b),static_cast<int>(0x31c),0,"One of the volume corruption logs is unavailable for being operated on."},
{ static_cast<int>(0xc000080c),static_cast<int>(0x31d),0,"One of the volume corruption logs was deleted while still having corruption records in them. The volume contains detected corruptions and must be scanned."},
{ static_cast<int>(0xc000080d),static_cast<int>(0x31e),0,"One of the volume corruption logs was cleared by chkdsk and no longer contains real corruptions."},
{ static_cast<int>(0xc000080e),static_cast<int>(0x31f),0,"Orphaned files exist on the volume but could not be recovered because no more new names could be created in the recovery directory. Files must be moved from the recovery directory."},
{ static_cast<int>(0xc000080f),static_cast<int>(0x4d5),EAGAIN,"The operation could not be completed because an instance of Proactive Scanner is currently running."},
{ static_cast<int>(0xc0000810),static_cast<int>(0x328),0,"The read or write operation to an encrypted file could not be completed because the file has not been opened for data access."},
{ static_cast<int>(0xc0000811),static_cast<int>(0x54f),0,"One of the volume corruption logs comes from a newer version of Windows and contains corruption records. The log will be emptied and reset to the current version, and the volume health state will be updated accordingly."},
{ static_cast<int>(0xc0000901),static_cast<int>(0xdc),0,"This file is checked out or locked for editing by another user."},
{ static_cast<int>(0xc0000902),static_cast<int>(0xdd),0,"The file must be checked out before saving changes."},
{ static_cast<int>(0xc0000903),static_cast<int>(0xde),0,"The file type being saved or retrieved has been blocked."},
{ static_cast<int>(0xc0000904),static_cast<int>(0xdf),0,"The file size exceeds the limit allowed and cannot be saved."},
{ static_cast<int>(0xc0000905),static_cast<int>(0xe0),0,"Access Denied. Before opening files in this location, you must first browse to the web site and select the option to login automatically."},
{ static_cast<int>(0xc0000906),static_cast<int>(0xe1),0,"Operation did not complete successfully because the file contains a virus or potentially unwanted software."},
{ static_cast<int>(0xc0000907),static_cast<int>(0xe2),0,"This file contains a virus or potentially unwanted software and cannot be opened. Due to the nature of this virus or potentially unwanted software, the file has been removed from this location."},
{ static_cast<int>(0xc0000908),static_cast<int>(0x317),0,"The resources required for this device conflict with the MCFG table."},
{ static_cast<int>(0xc0000909),static_cast<int>(0x322),0,"The operation did not complete successfully because it would cause an oplock to be broken. The caller has requested that existing oplocks not be broken."},
{ static_cast<int>(0xc000090a),static_cast<int>(0x80090003),0,"Bad key."},
{ static_cast<int>(0xc000090b),static_cast<int>(0x80090005),0,"Bad data."},
{ static_cast<int>(0xc000090c),static_cast<int>(0x8009000d),0,"Key does not exist."},
{ static_cast<int>(0xc0000910),static_cast<int>(0x326),0,"Access to the specified file handle has been revoked."},
{ static_cast<int>(0xc0009898),static_cast<int>(0x29e),0,"WOW Assertion Error."},
{ static_cast<int>(0xc000a000),static_cast<int>(0x80090006),0,"The cryptographic signature is invalid."},
{ static_cast<int>(0xc000a001),static_cast<int>(0x8009002f),0,"The cryptographic provider does not support HMAC."},
{ static_cast<int>(0xc000a002),static_cast<int>(0x17),0,"The computed authentication tag did not match the input authentication tag."},
{ static_cast<int>(0xc000a003),static_cast<int>(0x139f),0,"The requested state transition is invalid and cannot be performed."},
{ static_cast<int>(0xc000a004),static_cast<int>(0x154),0,"The supplied kernel information version is invalid."},
{ static_cast<int>(0xc000a005),static_cast<int>(0x155),0,"The supplied PEP information version is invalid."},
{ static_cast<int>(0xc000a006),static_cast<int>(0x32b),0,"Access to the specified handle has been revoked."},
{ static_cast<int>(0xc000a007),static_cast<int>(0x32),0,"The file operation will result in the end of file being on a ghosted range."},
{ static_cast<int>(0xc000a010),static_cast<int>(0xea),0,"The IPSEC queue overflowed."},
{ static_cast<int>(0xc000a011),static_cast<int>(0xea),0,"The neighbor discovery queue overflowed."},
{ static_cast<int>(0xc000a012),static_cast<int>(0x4d0),0,"An ICMP hop limit exceeded error was received."},
{ static_cast<int>(0xc000a013),static_cast<int>(0x32),0,"The protocol is not installed on the local machine."},
{ static_cast<int>(0xc000a014),static_cast<int>(0x4d1),0,"An operation or data has been rejected while on the network fast path."},
{ static_cast<int>(0xc000a080),static_cast<int>(0x314),0,"{Delayed Write Failed}\nWindows was unable to save all the data for the file %hs; the data has been lost.\nThis error may be caused by network connectivity issues. Please try to save this file elsewhere."},
{ static_cast<int>(0xc000a081),static_cast<int>(0x315),0,"{Delayed Write Failed}\nWindows was unable to save all the data for the file %hs; the data has been lost.\nThis error was returned by the server on which the file exists. Please try to save this file elsewhere."},
{ static_cast<int>(0xc000a082),static_cast<int>(0x316),0,"{Delayed Write Failed}\nWindows was unable to save all the data for the file %hs; the data has been lost.\nThis error may be caused if the device has been removed or the media is write-protected."},
{ static_cast<int>(0xc000a083),static_cast<int>(0x5b9),0,"Windows was unable to parse the requested XML data."},
{ static_cast<int>(0xc000a084),static_cast<int>(0x5ba),0,"An error was encountered while processing an XML digital signature."},
{ static_cast<int>(0xc000a085),static_cast<int>(0x5bc),0,"Indicates that the caller made the connection request in the wrong routing compartment."},
{ static_cast<int>(0xc000a086),static_cast<int>(0x5bd),0,"Indicates that there was an AuthIP failure when attempting to connect to the remote host."},
{ static_cast<int>(0xc000a087),static_cast<int>(0x21bd),0,"OID mapped groups cannot have members."},
{ static_cast<int>(0xc000a088),static_cast<int>(0x21be),0,"The specified OID cannot be found."},
{ static_cast<int>(0xc000a089),static_cast<int>(0x21c6),0,"The system is not authoritative for the specified account and therefore cannot complete the operation. Please retry the operation using the provider associated with this account. If this is an online provider please use the provider's online site."},
{ static_cast<int>(0xc000a100),static_cast<int>(0x3bc4),0,"Hash generation for the specified version and hash type is not enabled on server."},
{ static_cast<int>(0xc000a101),static_cast<int>(0x3bc5),0,"The hash requests is not present or not up to date with the current file contents."},
{ static_cast<int>(0xc000a121),static_cast<int>(0x3bd9),0,"The secondary interrupt controller instance that manages the specified interrupt is not registered."},
{ static_cast<int>(0xc000a122),static_cast<int>(0x3bda),0,"The information supplied by the GPIO client driver is invalid."},
{ static_cast<int>(0xc000a123),static_cast<int>(0x3bdb),0,"The version specified by the GPIO client driver is not supported."},
{ static_cast<int>(0xc000a124),static_cast<int>(0x3bdc),0,"The registration packet supplied by the GPIO client driver is not valid."},
{ static_cast<int>(0xc000a125),static_cast<int>(0x3bdd),0,"The requested operation is not suppported for the specified handle."},
{ static_cast<int>(0xc000a126),static_cast<int>(0x3bde),0,"The requested connect mode conflicts with an existing mode on one or more of the specified pins."},
{ static_cast<int>(0xc000a141),static_cast<int>(0x3c28),0,"The requested run level switch cannot be completed successfully since\none or more services refused to stop or restart."},
{ static_cast<int>(0xc000a142),static_cast<int>(0x3c29),0,"The service has an invalid run level setting. The run level for a service\nmust not be higher than the run level of its dependent services."},
{ static_cast<int>(0xc000a143),static_cast<int>(0x3c2a),0,"The requested run level switch cannot be completed successfully since\none or more services will not stop or restart within the specified timeout."},
{ static_cast<int>(0xc000a145),static_cast<int>(0x3c2b),0,"A run level switch agent did not respond within the specified timeout."},
{ static_cast<int>(0xc000a146),static_cast<int>(0x3c2c),0,"A run level switch is currently in progress."},
{ static_cast<int>(0xc000a200),static_cast<int>(0x109a),0,"This operation is only valid in the context of an app container."},
{ static_cast<int>(0xc000a201),static_cast<int>(0x109c),0,"This functionality is not supported in the context of an app container."},
{ static_cast<int>(0xc000a202),static_cast<int>(0x109d),0,"The length of the SID supplied is not a valid length for app container SIDs."},
{ static_cast<int>(0xc000a203),static_cast<int>(0x5),EACCES,"Access to the specified resource has been denied for a less privileged app container."},
{ static_cast<int>(0xc000a281),static_cast<int>(0x1130),0,"Fast Cache data not found."},
{ static_cast<int>(0xc000a282),static_cast<int>(0x1131),0,"Fast Cache data expired."},
{ static_cast<int>(0xc000a283),static_cast<int>(0x1132),0,"Fast Cache data corrupt."},
{ static_cast<int>(0xc000a284),static_cast<int>(0x1133),0,"Fast Cache data has exceeded its max size and cannot be updated."},
{ static_cast<int>(0xc000a285),static_cast<int>(0x1134),0,"Fast Cache has been ReArmed and requires a reboot until it can be updated."},
{ static_cast<int>(0xc000a2a1),static_cast<int>(0x1158),0,"The copy offload read operation is not supported by a filter."},
{ static_cast<int>(0xc000a2a2),static_cast<int>(0x1159),0,"The copy offload write operation is not supported by a filter."},
{ static_cast<int>(0xc000a2a3),static_cast<int>(0x115a),0,"The copy offload read operation is not supported for the file."},
{ static_cast<int>(0xc000a2a4),static_cast<int>(0x115b),0,"The copy offload write operation is not supported for the file."},
{ static_cast<int>(0xc000ce01),static_cast<int>(0x171),0,"The provider that supports file system virtualization is temporarily unavailable."},
{ static_cast<int>(0xc000ce02),static_cast<int>(0x172),0,"The metadata for file system virtualization is corrupt and unreadable."},
{ static_cast<int>(0xc000ce03),static_cast<int>(0x173),0,"The provider that supports file system virtualization is too busy to complete this operation."},
{ static_cast<int>(0xc000ce04),static_cast<int>(0x174),0,"The provider that supports file system virtualization is unknown."},
{ static_cast<int>(0xc000cf00),static_cast<int>(0x166),0,"The Cloud File provider is unknown."},
{ static_cast<int>(0xc000cf01),static_cast<int>(0x16a),0,"The Cloud File provider is not running."},
{ static_cast<int>(0xc000cf02),static_cast<int>(0x16b),0,"The Cloud File metadata is corrupt and unreadable."},
{ static_cast<int>(0xc000cf03),static_cast<int>(0x16c),0,"The operation could not be completed because the Cloud File metadata is too large."},
{ static_cast<int>(0xc000cf06),static_cast<int>(0x177),0,"The operation could not be completed because the Cloud File metadata version is not supported."},
{ static_cast<int>(0xc000cf07),static_cast<int>(0x178),0,"The operation could not be completed because the file is not a Cloud File."},
{ static_cast<int>(0xc000cf08),static_cast<int>(0x179),0,"The operation could not be completed because the Cloud File is not in sync."}

