<b>Fortran Library</b>

- @ref FH5A "Attributes (H5A)"
<br />
HDF5 attribute is a small metadata object describing the nature and/or intended usage of a primary data object.

- @ref FH5D "Datasets (H5D)"
<br />
Manage HDF5 datasets, including the transfer of data between memory and disk and the description of dataset properties.

- @ref FH5S "Dataspaces (H5S)"
<br />
HDF5 dataspaces describe the shape of datasets in memory or in HDF5 files.

- @ref FH5T "Datatypes (H5T)"
<br />
HDF5 datatypes describe the element type of HDF5 datasets and attributes.

- @ref FH5E "Error Handling (H5E)"
<br />
HDF5 library error reporting.

- @ref FH5F "Files (H5F)"
<br />
Manage HDF5 files.

- @ref FH5Z "Filters (H5Z)"
<br />
Manage HDF5 user-defined filters

- @ref FH5G "Groups (H5G)"
<br />
Manage HDF5 groups.

- @ref FH5I "Identifiers (H5I)"
<br />
Manage identifiers defined by the HDF5 library.

- @ref FH5 "Library General (H5)"
<br />
Manage the life cycle of HDF5 library instances.

- @ref FH5L "Links (H5L)"
<br />
Manage HDF5 links and link types.

- @ref FH5O "Objects (H5O)"
<br />
Manage HDF5 objects (groups, datasets, datatype objects).

- @ref FH5P "Property Lists (H5P)"
<br />
HDF5 property lists are the main vehicle to configure the behavior of HDF5 API functions.

- @ref FH5R "References (H5R)"
<br />
Manage HDF5 references (HDF5 objects, attributes, and selections on datasets a.k.a. dataset regions).

- @ref FH5LT "High Level Lite (H5LT)"
<br />
Functions to simplify creating and manipulating datasets, attributes and other features

- @ref FH5IM "High Level Image (H5IM)"
<br />
Creating and manipulating HDF5 datasets intended to be interpreted as images

- @ref FH5TB "High Level Table (H5TB)"
<br />
Creating and manipulating HDF5 datasets intended to be interpreted as tables

- @ref FH5DS "High Level Dimension Scale (H5DS)"
<br />
Creating and manipulating HDF5 datasets that are associated with the dimension of another HDF5 dataset
