#pragma once
#include <Device/Protocol/ProtocolFactoryInterface.hpp>

namespace Protocols
{
class PhidgetProtocolFactory final : public Device::ProtocolFactory
{
  SCORE_CONCRETE("46c28ec5-3d7a-42cd-a730-0ac97d01eea7")
  // Implement with OSSIA::Device
  QString prettyName() const override;
  QUrl manual() const noexcept override;

  Device::DeviceInterface* makeDevice(
      const Device::DeviceSettings& settings,
      const score::DocumentContext& ctx) override;
  const Device::DeviceSettings& defaultSettings() const override;

  Device::ProtocolSettingsWidget* makeSettingsWidget() override;

  QVariant makeProtocolSpecificSettings(const VisitorVariant& visitor) const override;

  void serializeProtocolSpecificSettings(
      const QVariant& data, const VisitorVariant& visitor) const override;

  bool checkCompatibility(
      const Device::DeviceSettings& a, const Device::DeviceSettings& b) const override;

  Device::AddressDialog* makeAddAddressDialog(
      const Device::DeviceInterface& dev, const score::DocumentContext& ctx,
      QWidget*) override;
  Device::AddressDialog* makeEditAddressDialog(
      const Device::AddressSettings&, const Device::DeviceInterface& dev,
      const score::DocumentContext& ctx, QWidget*) override;
};
}
